/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

var TLAdminController = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.domAdminTab = data.domAdminTab;
	self.domTimelineBlock = $(self.domRoot).find("#tl-tab-my-timelines").get()[0];
	self.domTimelineList = $(self.domTimelineBlock).find("#tl-tab-my-timelines-timeline-list").get()[0];
	self.domTimelineFormSwitch = $(self.domRoot).find(".tl-ah-switch-block-control-timeline").get()[0];
	self.domTimelineForm = $(self.domRoot).find("#tl-ah-switch-block-timeline-form").get()[0];
	self.domUpdateTimelineForm = $(self.domRoot).find("#tab-my-selected-timeline-basic-info").get()[0];

	self.domSelectedTimelineHeadline = $(self.domRoot).find("#tl-ah-selected-timeline-headline span").get()[0];
	self.domEditTimeline = $(self.domRoot).find("#tl-ah-selected-timeline-headline a").get()[0];
	self.domSelectedTimelineStoryTab = $(self.domRoot).find("#tl-tab-my-selected-timeline-story-list").get()[0];

	self.domSelectedStoryHeadline = $(self.domRoot).find("#tl-ah-selected-story-headline").get()[0];
	self.domStoryForm = $(self.domRoot).find("#tl-tab-selected-story-basic-info").get()[0];
	self.domStoryMediaTab = $(self.domRoot).find("#tl-tab-selected-story-extra-media").get()[0];
	self.domStoryMediaForm = $(self.domRoot).find("#tl-ah-story-media-form").get()[0];
	self.domStoryMediaThumb = $(self.domStoryMediaForm).find(".tl-ah-media-thumb-holder div").get()[0];
	self.domStoryMediaMenuButton = $(self.domRoot).find("#tl-extra-media-tab-menu-item").get()[0];
	self.domTimelineInitalFocusSelect = $(self.domUpdateTimelineForm).find(".tl-ah-initial-focus-select").get()[0];
	self.domTimelineZoomField = $(self.domUpdateTimelineForm).find(".tl-ah-field-zoom").get()[0];

	self.domAccountTab = $(self.domRoot).find("#tl-tab-my-account").get()[0];

	self.domTimelineZoomSelect = $(self.domRoot).find("#tl-ah-timeline-zoom-select").get()[0];

	self.domSelectedStoryMediaHeadline = $(self.domRoot).find("#tl-ah-selected-media-title").get()[0];

	self.domStoryBasicInfoTabButton = $(self.domRoot).find("#tl-tab-selected-story-basic-info-button").get()[0];

	self.domCategoriesTab = $(self.domRoot).find("#tab-my-selected-timeline-categories").get()[0];
	self.domCategoriesForm = $(self.domRoot).find("#tl-ah-categories-form").get()[0];
	self.domSelectedCategoryTitle = $(self.domRoot).find("#tl-ah-selected-category-title").get()[0];
	
	self.domCreateNewTimelineButton = $(self.domRoot).find("#tl-ah-create-new-timeline-button").get()[0];

	self.domStoryCategorySelect = $(self.domRoot).find("#tl-ah-story-category-select").get()[0];
	self.domFeedCategorySelect = $(self.domRoot).find("#tl-ah-feed-category-select").get()[0];
	

	self.domAlert = $(self.domRoot).find("#tl-ah-alert").get()[0];
	self.domAlertInner = $(self.domAlert).find(".tl-ah-alert-inner").get()[0];
	self.domAlertContent = $(self.domAlert).find(".tl-ah-alert-content").get()[0];
	self.adminAlertController = "";

	self.domEventCatcher = $(self.domRoot).find("#tl-ah-event-catcher").get()[0];
	self.eventCatcherController = "";
	
	self.user = data.user;
	self.timelineFormVerification = "";
	self.updateTimelineFormVerification = "";
	self.mainController = data.mainController;
	self.contentPanelController = self.mainController.contentPanelController;
	self.timeline = data.timeline;
	
	self.storyFormVerifier = "";
	self.storyMediaFormVerifier = "";
	self.selectedStory = "";
	
	self.storyListController = "";
	self.timelineListController = "";
	self.storyMediaListController = "";
	self.selectedMediaItem = "";
	
	self.categoriesListController = "";
	self.selectedCategoryItem = "";
	self.categoriesFormVerifier = "";
	self.adminVisible =  true;
	
	self.tabOpenedFuncs = new Array();
	self.lastOpenedSectionTab = new Array();
	self.zoomSelectReplacer = "";
	
	self.domFeedItemSelector = $(".tl-ah-feed-item-selector").get()[0];
	self.imageSelector = "";
	self.accountVerifier = "";
	self.helpController = "";
	self.domGeneralPanelPrototype = $("#tl-general-purpose-panel-prototype").get()[0];
	self.promotionPanel = "";
	self.showHelp = true;
	
	self.embedVerifier = "";
	
	self.reducedListHeight = 100;
	self.mediumListHeight = 150;
	self.enlargedListHeight = 200;
	
	self.adminTabStatusCookieName = "TLAdminTabStatusCookie";
}

TLAdminController.prototype = {
	init: function() {
		var self = this;	
		
		self.turnNewAdminOn();

		if ($.browser.isIOS) {		
			self.expandedAdminActive = true;
		}
		
		if (self.expandedAdminActive) {
			self.activateExpandedAdmin();	
		}

		$(self.domRoot).hover( function() {
			theAJKMouseScrollEvent.registerAsObserver({ observer: self });
			theTLMainController.selected3DView.disableHover = true;
		}, function() {
			theAJKMouseScrollEvent.removeAsObserver({ observer: self });
			if (!TLAdminLightbox.aBoxIsOpen) {
				theTLMainController.selected3DView.disableHover = false;
			}
		});

		self.mainController.user.accountType = $("#tl-ah-user-account-type").text();
		self.mainController.user.maxNumTimelines = parseInt($("#tl-ah-max-num-tls").text());

		$("body").addClass("tl-user-type-"+self.mainController.user.accountType.toLowerCase());
		
		/*self.storyListContentScroller =	new AJKContentScrollerController({
			domRootEl: $(self.domRoot).find("#tl-tab-my-selected-timeline-story-list .ajk-cs-carousel").get()[0],
			maxHeight: 500
		}).init();*/
						
		// We need a way of interupting the default create new timtlines functionaluty
		// to check whether someone is allowed a new timeline

		$(self.domGeneralPanelPrototype).attr("id","");
		$(self.domGeneralPanelPrototype).remove();

		self.helpController = new TLAdminHelp({
			domRoot: $("#tl-admin-help-holder").get()[0],
			domAdmin: self.domRoot,
			domOpenClose: $("#tl-admin-help-open-close").get()[0],
			mainController: self
		}).init();
	
		self.generateTimelineScaleList();

		$(self.domRoot).find("#tl-stories-tab-menu-item").click( function() {
			if (self.selectedStory) {
				setTimeout( function() {
					self.storyListController.resetHeightTo({ height: self.reducedListHeight });
					self.selectStory({ story: self.selectedStory, cancelCentering: true });
				},1);
			}
			else {
				self.helpController.setBaseHelpByName({ baseName: "default" });
				setTimeout( function() {
					self.storyListController.resetHeightTo({ height: self.enlargedListHeight });
				},1);
			}
		});

		self.eventCatcherController = new TLAdminEventCatcher({
			domRoot: self.domEventCatcher,
            controller: self
		}).init();

		self.adminAlertController = new AJKAlert({
			domRoot: self.domAlert,
			preDisplaySetupFunc: function() {
				// here we resize the alert's inner el to fit the size of the admin panel	
				var adminPanelHeight = AJKHelpers.calculateDomElHeight({domEl: self.domRoot });
				$(self.domAlertInner).css({ height: adminPanelHeight - 16});
				var contentHeight = AJKHelpers.calculateDomElHeight({domEl: self.domAlertContent })+10; // Padding
				var contentPos = parseInt((adminPanelHeight-contentHeight-16)/2,10);
				$(self.domAlertContent).css({ top: contentPos });
			}
		}).init();

		$(self.domAdminTab).click( function() {
			if (self.adminVisible) {
				$(self.domRoot).css({display: "none"});
				$(this).addClass("tl-admin-main-tab-admin-hidden");
				$(self.helpController.domOpenClose).css({ visibility: "hidden" });
				self.adminVisible = false;
				self.helpController.hide();		
				AJKHelpers.setCookie({
					name: self.adminTabStatusCookieName,
					value: "admin-closed",
					expires: 0
				});

			}
			else {
				$(self.domRoot).css({display: "block"});
				$(this).removeClass("tl-admin-main-tab-admin-hidden");
				$(self.helpController.domOpenClose).css({ visibility: "visible" });
				self.adminVisible = true;
				if (self.showHelp) {		
					self.helpController.show();
				}		
				AJKHelpers.deleteCookie({ name: self.adminTabStatusCookieName });
			}
			return false;
		});
		self.generateCategoryLists();

		new AJKTabBlockController({
			domRoot: $(self.domRoot).find("#tl-ah-main-menu").get()[0],
			tabMenuOptionClass: "tl-tab-option",
			tabSelectedClass: "tl-ah-selected"
		}).init();
		
		new AJKTabBlockController({
			domRoot: $(self.domRoot).find("#tl-ah-menu-selected-timeline-menu").get()[0],
			tabMenuOptionClass: "tl-tab-option",
			tabSelectedClass: "tl-ah-selected"
		}).init();
		
		new AJKTabBlockController({
			domRoot: $(self.domRoot).find("#tl-block-selected-timeline-story").get()[0],
			tabMenuOptionClass: "tl-tab-option",
			tabSelectedClass: "tl-ah-selected"
		}).init();

		new AJKSwitchBlockController({
			domRoot: self.domRoot,
			switchClass: "tl-ah-switch-block-control",
			switchSelectedClass: "tl-ah-switch-block-control-selected"
		}).init();
		
		$(self.domRoot).find("#tl-ah-create-new-story-button").click( function() {
			self.createNewStory();
			return false;
		});
		
		$(self.domRoot).find("#tl-ah-story-add-media-button a").click( function() {
			self.createNewMediaItem();
			return false;
		});
		
		$(self.domRoot).find("#tl-ah-create-new-category-button a").click( function() {
			self.createNewCategoryItem();
			return false;
		});
		
		$(self.domEditTimeline).click( function() {
			$("#tl-settings-tab-menu-item").click();
			return false;
		});
		
		self.setupTabOpenedFuncs();
		
		self.setupVerification();

		self.initialiseTimelineList();

		self.setupStoryMediaList();
		
		self.setupCategoryList();

		self.adminTagController = new TLAdminTagController({
			controller: self	
		}).init();

		self.adminSpanController = new TLAdminSpanController({
			controller: self	
		}).init();

		// Must come before setUpFlickrImageSelector
		TLAdminLightbox.panelPrototype = $(self.domFeedItemSelector).clone().get()[0];
		$(TLAdminLightbox.panelPrototype).find(".tl-panel-specific-content").empty();
		$(self.domFeedItemSelector).after(TLAdminLightbox.panelPrototype);

		self.setUpVideoSelector();
		self.setUpImageSelector();
		
		self.setupAccountForm();
		
		//self.setupEmbed();
		
		new TLCSVServices().init();
		new TLPDFServices({controller: self}).init();
		
		self.showHelp = theTLParantWindow.NSDocument.shouldDisplayHelp();

		// Now display help if needed
		if (self.showHelp) {
			self.helpController.show();	
		}
		else {
			self.helpController.hide();	
		}
		
		
		$(self.domRoot).find("#tl-ah-minimise-story-block").click( function() {
			self.minimiseStoryBlock();
			return false;
		});
		
		$(self.domRoot).find("#tl-ah-minimise-new-timeline-block").click( function() {
			self.hideNewTimelineForm();
			return false;
		});
		
		if (self.mainController.user.accountType == "Teacher" ) {
			//new TLAdminTeacherExtras({ controller: self }).init();
		}
		
		if (self.mainController.user.accountType == "Standard" ) {
			self.initialisePupilUpgrade();
		}
		
		new TLAdminFeedController({
			controller: self
		}).init();

		new TLTimelineAdvancedSettingsController({
			controller: self 
		}).init();

		new TLTimeline3DSettings({
			controller: self 
		}).init();

		self.hideShowZoomForSpacing();
		
		self.activate();
		
		if (!(self.user.accountType == "Silver" || self.user.accountType == "Teacher")) {
			// Remove the JSON option from feeds except for Silver and Teacher account users
			$("#tl-field-feed-source .tl-feed-source-json").remove();	
			$("#tl-ah-media-type-menu .map-option").remove();
		}

		if (self.timeline.showAdBlock == "true") {
			$("#tl-advert-block .tl-advb-remove-ad").css({ display: "block" }).click( function() {
				$(self.domRoot).find(".tl-pp-launch-promotion-panel").click();
				return false;
			});
		}
		new AJKDatePickerController({ domRoot: self.domRoot }).init();
		
		/*setTimeout( function() {
			//$("#tab-my-selected-timeline-basic-info").find(".tl-ah-image-field:eq(0) .tl-ah-search-button").click();
		}, 100);*/

		self.storyEditButton = new TLStoryEditButton({
			callback: function(data) {
				if (self.eventCatcherController.active) {
					self.eventCatcherController.fakeClick();
				}
				else {
					self.selectedStory = true;
					if (!$("#tl-tab-my-timelines-button").hasClass("tl-ah-selected")) {
						$("#tl-tab-my-timelines-button").click();
					}
					$("#tl-stories-tab-menu-item").click();
					self.selectStory( { story: data.story, cancelCentering: true });
				}
			},
			controller: self	
		}).init();
		
		if (self.mainController.userControlsController) {
			self.userControlsExtended = new TLUserControlsExtender({
				userControlsController: self.mainController.userControlsController,
				controller: self
			}).init();	
		}	

		new AJKValueToggler({
			domRoot: $("#tl-ah-toggle-admin-style").get()[0],
			values: ["new","old"],
			changeCallback: function(data) {
				if (data.value == "new") {
					self.turnNewAdminOn();
				}
				else {
					self.turnNewAdminOff();
				}
			}
		}).init();
		
		$("#tl-ah-print-timeline").click( function() {
			theTLParantWindow.NSDocument.invokePrint();
			return false;
		});

		return self;
	},
	activateExpandedAdmin: function() {
		var self = this;
		$("body").addClass("tl-admin-expanded");
		self.enlargedListHeight = 386;
		
		$("#tl-ah-field-id-text").parents(".tl-ah-input-textarea").addClass("tl-ah-input-textarea-large");
	},
	turnNewAdminOn: function() {
		var self = this;
		if (!($.browser.msie && !$.browser.isModernIE)) {
			$("body").addClass("tl-admin-new");
		}
	},
	turnNewAdminOff: function() {
		var self = this;	
		$("body").removeClass("tl-admin-new");
	},
	activate: function() {
		var self = this;
		
		var cookieData = AJKHelpers.getCookie({ name: self.adminTabStatusCookieName });
		
		var readyToDisplayFunc = function() {
			$(self.domRoot).css({ visibility: "visible" });
			$(self.domAdminTab).css({ visibility: "visible" });
			$(self.helpController.domRoot).css({ visibility: "visible" });
			$(self.helpController.domOpenClose).css({ visibility: "visible" });
			if (cookieData == "admin-closed" && !tlIsTimelineNew) {
				$(self.domAdminTab).click();
			}
		}

		if (self.timeline.feeds && self.timeline.feeds.length > 0) {
			(function() {
				var thisFunc = arguments.callee;
				setTimeout( function() {
					if (self.mainController.initialFeedsLoaded) {
						readyToDisplayFunc();
					}
					else {
						thisFunc();
					}
				},100);
			})();
		}
		else {
			readyToDisplayFunc();
		}
	},
	hideShowZoomForSpacing: function() {
		var self = this;
		if (!self.domTimelineZoomField) {
			return;	
		}
		
		if (self.timeline.markerSpacing=="equal") {
				$(self.domTimelineZoomField).removeClass("tl-ah-hide").addClass("tl-ah-hide");
		}
		else {
				$(self.domTimelineZoomField).removeClass("tl-ah-hide");
		}
	
	},
	initialisePupilUpgrade: function() {
		var self = this;
	},
	showNewTimelineForm: function() {
		var self = this;
		$(self.domTimelineForm).css({ display: "block" });
		if (self.timelineListController) {
			self.timelineListController.resetHeightTo({ height: self.reducedListHeight });
		}
	},
	hideNewTimelineForm: function() {
		var self = this;
		$(self.domTimelineForm).css({ display: "none" });
		if (self.timelineListController) {
			self.timelineListController.resetHeightTo({ height: self.enlargedListHeight });
		}
	},
	setupAccountForm: function() {
		var self = this;		
	},
	setUpVideoSelector: function() {

		var self = this;
		self.domVideoFeedItemSelector = $(self.domFeedItemSelector).clone().get()[0];
		self.videoSelector = new AJKVideoSelector({
			controller: self,
			timeline: self.timeline,
			domFeedItemSelector: self.domVideoFeedItemSelector
		}).init();	

		$(self.domRoot).find(".tl-ah-video-field").each( function() {
			var thisDomInput = $(this).find("input").get()[0];
			
			var thisDomSearchButton = $(this).find(".tl-ah-video-search-button").get()[0];
                                                        
            // We use the image data uri field for storing video/audio bookmarks
            var domBookmarkDataField = "";
            var domBookmarkDataFieldId = $(this).find(".tl-ah-media-bookmark-field-id").text();
            if (domBookmarkDataFieldId) {
                domBookmarkDataField = $("#"+ domBookmarkDataFieldId).get()[0];
            }

			var thumbPosFieldId = $(this).find(".tl-ah-image-data-thumb-position").text();
			var domThumbPosField = "";
			if (thumbPosFieldId) {
				domThumbPosField = $("#"+thumbPosFieldId).get()[0];
			}
			$(thisDomSearchButton).click( function() {
				self.videoSelector.launch({
					domContentField: thisDomInput,
					domThumbPosField: domThumbPosField,
                    domBookmarkDataField: domBookmarkDataField
				});
				return false;
			});
		});
		
	},
	setUpImageSelector: function() {
		var self = this;
		
		self.imageSelector = new AJKImageSelector({
			controller: self,
			timeline: self.timeline,
			domFeedItemSelector: self.domFeedItemSelector
		}).init();
		
		$(self.domRoot).find(".tl-ah-image-field").each( function() {
			var thisDomInput = $(this).find("input").get()[0];
			var thisDomSearchButton = $(this).find(".tl-ah-search-button").get()[0];
			var imageSize = $(this).find(".tl-ah-image-data-size").text();
			var domCaptionField = "";
			var captionFieldId = $(this).find(".tl-ah-image-data-caption-field-id").text();
			if (captionFieldId) {
				domCaptionField = $("#"+captionFieldId).get()[0];
			}
			var domDataUriField = "";
			var dataUriFieldId = $(this).find(".tl-ah-image-data-data-uri-id").text();
			if (dataUriFieldId) {
				domDataUriField = $("#"+ dataUriFieldId).get()[0];
			}
			
			var thumbPosFieldId = $(this).find(".tl-ah-image-data-thumb-position").text(); 
			var domThumbPosField = "";
			if (thumbPosFieldId) {
				domThumbPosField = $("#"+thumbPosFieldId).get()[0];
			}
			$(thisDomSearchButton).click( function() {
				self.imageSelector.launch({
					imageSize: imageSize,
					domContentField: thisDomInput,
					domCaptionField: domCaptionField,
					domThumbPosField: domThumbPosField, 
					domDataUriField: domDataUriField
				});
				return false;
			});
		});

	},
	setupTabOpenedFuncs: function() {
		var self = this;	
				
		self.tabOpenedFuncs["story-basic-info"] = function() { self.storyBasicInfoPanelOpened(); }
		self.tabOpenedFuncs["story-media"] = function() { self.storyMediaPanelOpened(); }
		self.tabOpenedFuncs["story-extra-info"] = function() { self.storyExtraInfoPanelOpened(); }
		self.tabOpenedFuncs["story-tags"] = function() { self.adminTagController.storyTagsPanelOpened(); }
		self.tabOpenedFuncs["section-categories"] = function() { self.categoryPanelOpened(); }
		self.tabOpenedFuncs["section-spans"] = function() { self.adminSpanController.spanPanelOpened(); }
		self.tabOpenedFuncs["section-basic-info"] = function() { self.timelineBasicInfoPanelOpened(); }
		
		self.tabOpenedFuncs["section-story"] = function() {
			var lastOpenedSubSection = self.lastOpenedSectionTab["section-story"] || "story-basic-info";
			if (self.tabOpenedFuncs[lastOpenedSubSection]) {
				self.tabOpenedFuncs[lastOpenedSubSection]();
			}
			
		}
		
		$(self.domRoot).find(".tl-ah-menu li").each( function() {
			var tabName = $(this).attr("tabName");
			if (tabName && self.tabOpenedFuncs[tabName]) {

				var tabSubSection = "section-"+tabName.split("-")[0];
				var isSectionLeader = tabName.indexOf("section") != -1; 
				$(this).find("a").click( function(e) {
					setTimeout( function() {
						if (isSectionLeader) {
							self.lastOpenedSectionTab["section"] = tabName;
						}
						else {
							self.lastOpenedSectionTab[tabSubSection] = tabName;
						}
						self.tabOpenedFuncs[tabName]();
					},1);
					e.preventDefault();
				});	
				
			}
		});
		
		
		/* Deal with return to Story list functionality */
		
		$(self.domRoot).find(".tl-ah-back-to-story-list").click( function() {
			if (self.eventCatcherController.active) {
				self.eventCatcherController.fakeClick();
			}
			else {
				self.minimiseStoryBlock({ dontDeselectItem: true });
			}
			return false;
		});
		

	},
	generateCategoryLists: function() {
		var self = this;

		var insertHTML = "";		
		insertHTML += '<option value="default">'+TLConfigText['adminBasic_Undefined'] +'</option>';
		$.each(self.timeline.categories, function() {
			if (!this.autoGenerated) {
				insertHTML += '<option value="'+this.id+'">'+this.title+'</option>';
			}
		});

		$(self.domStoryCategorySelect).empty().append(insertHTML);
		// Also create list for feed
		$(self.domFeedCategorySelect).empty().append(insertHTML);
	},
	updateCategoryLists: function() {
		var self = this;
		self.generateCategoryLists();
		if (self.selectedStory) {
			self.storyFormVerifier.setFieldValues({
				fieldValues: {
					category: self.selectedStory.category.id
				}
			});
		}
	},
	generateTimelineScaleList: function() {
		var self = this;
		var insertHTML = "";		
		$.each(self.mainController.selectedView.availableScales, function() {
			insertHTML += '<option value="'+this.name+'">'+this.name+'</option>';
		});

		$(self.domTimelineZoomSelect).empty().append(insertHTML);
	},
	refreshTimelineZoomSelector: function() {
		var self = this;
		
				
		self.generateTimelineScaleList();

		if (self.zoomSelectReplacer) {
			self.zoomSelectReplacer.refresh();
		}
		else {
			self.zoomSelectReplacer = new AJKSelectReplacer({
				domSelect: self.domTimelineZoomSelect,
				createItemFunc: function(data) {
					var val = data.val;
					var text = data.text;
					
					var domZoomItem = $('<a class="tl-ah-zoom-item" href="#">'+text+'</a>').get()[0];
					return domZoomItem; 
				},
				itemSelectedClass: "tl-ah-zoom-item-selected"
			}).init();
		}		
		self.zoomSelectReplacer.selectItemFromVal({ val: self.timeline.zoom });
	},
	setupVerification: function() {
		var self = this;	

		self.accountVerifier = new AJKVerifier({
			domRootEl: self.domAccountTab,
			revertFunc: function() {
				self.accountVerifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				var insertHTML = '<div>';
			}
		}).init();
		self.accountVerifier.saveFieldValues();
		self.accountVerifier.disableSaveAndRevert();
		
		
		self.accountVerifier.onChangeCallback = function(data) {
			if (data.fieldName == "showHelp" && data.fieldValue == 1) {
				self.helpController.show();
				self.showHelp = true;
			}
			else if (data.fieldName == "showHelp") {
				self.helpController.hide();
				self.showHelp = false;
			}
				
		}
		

		self.updateTimelineFormVerification = new AJKVerifier({
			domRootEl: self.domUpdateTimelineForm,
			revertFunc: function() {
				self.updateTimelineFormVerification.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				// Firstly check that dates are okay
				var startDate = Date.parse(data.fieldData["startDate"]);
				if (!self.verifyTimelineFormDate({verifier: self.updateTimelineFormVerification, date: startDate, dateType: "startDate"})) {
					return false;
				}
				var endDate = Date.parse(data.fieldData["endDate"]);
				if (!self.verifyTimelineFormDate({verifier: self.updateTimelineFormVerification, date: endDate, dateType: "endDate"})) {
					return false;
				}
				
				self.displayStandardSavingAlertMessage();

				// We need to convert the date fields to MYSQL DATETIME FORMAT
				data.fieldData["startDate"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["startDate"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});
				
				data.fieldData["timelineId"] = self.timeline.id;

				data.fieldData["endDate"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["endDate"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});

				data.fieldData["htmlFormatting"] = self.timeline.htmlFormatting;

				self.updateTimelineFormVerification.saveFieldValues();
				self.updateTimelineFormVerification.disableSaveAndRevert();

				self.eventCatcherController.deactivate();

				if (self.user.timelinesByKey[self.timeline.id].title != data.fieldData.title) {
					self.user.timelinesByKey[self.timeline.id].title = data.fieldData.title;
					$(self.domSelectedTimelineHeadline).text(data.fieldData.title);
				}

				// If timeline title is changed, need to update the timeline's title in multiple places
				
				self.updateTimelineSavedStatus({ status: "save-needed" });
				
				self.adminAlertController.fadeOut();
								
			}
		}).init();

		self.storyFormVerifier = new AJKVerifier({
			domRootEl: self.domStoryForm,
			cancelFunc: function() {
				self.deleteStory({story: self.selectedStory});
				self.storyListController.resetHeightTo({ height: self.enlargedListHeight });
				self.helpController.setBaseHelpByName({ baseName: "default" });
			},
			revertFunc: function() {
				self.storyFormVerifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				if (self.selectedStory.id == "awaitingId") {
					return false;
				}
				
				if (!self.isStoryStartDateInTimelineRange({ startDate: Date.parse(data.fieldData["startDate"]) })) {
					return;	
				}

				self.displayStandardSavingAlertMessage();
					
				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["storyId"] = self.selectedStory.id;
				
				vars["category"] = (vars["category"] == "default") ? 0 : vars["category"];

				self.syncStoryStartEndDates({ oldStoryStartDate: self.selectedStory.startDate });

				// We need to convert the date fields to MYSQL DATETIME FORMAT

				data.fieldData["startDate"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["startDate"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});

				data.fieldData["endDate"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["endDate"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});
				
				self.selectedStory.setValue({
					valueName: "fullText",
					value: vars["fullText"]	
				});

				self.updateContentPanel({ story: self.selectedStory });
				self.selectedStory.id = (self.selectedStory.id) ? self.selectedStory.id : "awaitingId";
				
				self.storyFormVerifier.saveFieldValues();
				self.storyFormVerifier.hideCancelButton();
				self.storyFormVerifier.showRevertButton();
				self.storyFormVerifier.disableSaveAndRevert();
				
				var relatedStory = self.selectedStory; 
				
				self.updateContentPanel({ story: self.selectedStory });
				
				self.eventCatcherController.deactivate();

				if (relatedStory.id == "awaitingId") {
					relatedStory.id = theTLCreateIdCounters.story++;
				}
				self.updateTimelineSavedStatus({ status: "save-needed" });
				self.adminAlertController.fadeOut();
                self.mainController.selected3DView.redisplay();

			}
		}).init();
		
		self.storyMediaFormVerifier = new AJKVerifier({
			domRootEl: self.domStoryMediaForm,
			cancelFunc: function() {
				self.deleteMediaItem({mediaItem: self.selectedMediaItem});
			},
			revertFunc: function() {
				self.storyMediaFormVerifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				if (!self.selectedStory.id) {
					//alert("We need to ensure the story has been created at this point.");
					return;	
				}
				self.displayStandardSavingAlertMessage();

				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["storyId"] = self.selectedStory.id;
				vars["mediaId"] = self.selectedMediaItem.id;
				
				// We should probably update a story's media files at this point
				var relatedMediaItem = self.selectedMediaItem;
				var relatedStory = self.selectedStory;
				
				var newItem = (self.selectedMediaItem.id == "awaitingId") ? true : false; 
				
				var sourceHasChanged = (self.storyMediaFormVerifier.isValueDifferentFromSavedValueForField({ fieldName: "src" }) || self.storyMediaFormVerifier.isValueDifferentFromSavedValueForField({ fieldName: "type" }));  
				
				var submitCompleted = function() {

					self.storyMediaFormVerifier.saveFieldValues();
					self.storyMediaFormVerifier.hideCancelButton();
					self.storyMediaFormVerifier.showRevertButton();
					self.storyMediaFormVerifier.disableSaveAndRevert();
					
					self.eventCatcherController.deactivate();
					if (newItem) {
						var mediaId = theTLCreateIdCounters.media++;
						relatedMediaItem.id = mediaId;
						relatedStory.addMediaItem({ mediaItem: relatedMediaItem });	
						
						if (self.selectedStory == relatedStory) { 
							self.storyMediaListController.resetWithNewListItems({ listItems: self.selectedStory.media });
							self.storyMediaListController.showAndSelectListItem({ listItem: relatedMediaItem, instantly: true });
						}
					}

					relatedStory.mediaHasBeenUpdated();
					self.updateContentPanel({ story:relatedStory });
					self.adminAlertController.fadeOut();
					
					self.loadMediaThumb({
						mediaItem: relatedMediaItem
					});
					self.updateTimelineSavedStatus({ status: "save-needed" });
				}

				// A Quick fix - we will need to update AJAX controller option below
				if ((sourceHasChanged || newItem ) && (relatedMediaItem.type == "Video" || relatedMediaItem.type == "Audio")) {
					AJKHelpers.getExternalDataForMedia({ 
						media: relatedMediaItem,
						callback: function(data) {
							var externalData = data.externalData;
							
							if (!externalData) {
								submitCompleted();	
								return;	
							}

							var externalMediaThumb = externalData["externalMediaThumb"];
							var externalMediaId = externalData["externalMediaId"];
							var externalMediaType = externalData["externalMediaType"];

							if (externalMediaThumb) {
								relatedMediaItem.externalMediaThumb = externalMediaThumb;
								self.storyMediaFormVerifier.setFieldValues({
									fieldValues: {
										video_thumb: relatedMediaItem.externalMediaThumb
									}
								});
							} 
							else {
								relatedMediaItem.externalMediaThumb = vars["video_thumb"];
							}
							
							if (externalMediaId) {
								relatedMediaItem.externalMediaId = externalMediaId;
							}
							
							if (externalMediaType) {
								relatedMediaItem.externalMediaType = externalMediaType;
							}
							submitCompleted();	
						}		
					});
					
				}
				else {
					submitCompleted();	
				}
				
				// A Quick fix end

			}
		}).init();

		self.categoriesFormVerifier = new AJKVerifier({
			domRootEl: self.domCategoriesForm,
			cancelFunc: function() {
				self.deleteCategoryItem({categoryItem: self.selectedCategoryItem});
			},
			revertFunc: function() {
				self.categoriesFormVerifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				/*if (self.selectedCategoryItem.id == "awaitingId") {
					alert("We need to ensure the category has been created at this point.");	
				}*/

				self.displayStandardSavingAlertMessage();

				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["id"] = self.selectedCategoryItem.id;

				self.selectedCategoryItem.title = vars["title"];
				self.selectedCategoryItem.colour = vars["colour"];
				self.selectedCategoryItem.rows = vars["rows"];
				self.selectedCategoryItem.layout = vars["layout"];
				self.selectedCategoryItem.viewType = (vars["layout"] == 1) ? "duration" : "standard";

				var relatedCategoryItem = self.selectedCategoryItem;
				
				var newItem = (self.selectedCategoryItem.id == "awaitingId") ? true : false; 
								
				self.updateContentPanel({ story: self.selectedStory });

				self.categoriesFormVerifier.saveFieldValues();
				self.categoriesFormVerifier.hideCancelButton();
				self.categoriesFormVerifier.showRevertButton();
				self.categoriesFormVerifier.disableSaveAndRevert();
				
				self.eventCatcherController.deactivate();

				if (newItem) {
					var categoryId = theTLCreateIdCounters.category++;
					relatedCategoryItem.id = categoryId;
					self.mainController.addNewCategory({ category: relatedCategoryItem });
					if (self.selectedCategoryItem == relatedCategoryItem) { 
						self.categoriesListController.resetWithNewListItems({ listItems: self.getCategories() });
						self.categoriesListController.showAndSelectListItem({ listItem: relatedCategoryItem, instantly: true });
					}

					if (self.timeline.viewType == "category-band") {
							self.refreshTimelineView();
					}

				}
				else {
					// Sort the categories and redisplay
					self.mainController.sortCategories();
					self.categoriesListController.resetWithNewListItems({ listItems: self.getCategories() });
					if (self.selectedCategoryItem == relatedCategoryItem) { 
						self.categoriesListController.showAndSelectListItem({ listItem: relatedCategoryItem, instantly: true });
					}
					// If it is not a new item, then we need to iterate through all the stores/markers, 
					// and update the category name or color for the category that has changed
					$.each(self.timeline.markers, function() {
						if (this.category == relatedCategoryItem) {
							this.categoryHasChanged();	
						}
					});	

					self.mainController.selected3DView.redisplay();

					if (self.timeline.viewType == "category-band") {
						self.refreshTimelineView(); // This updates the order too
						//self.updateCategoryBand({ category: 	relatedCategoryItem });
					}
				}
				
				self.refreshUserControlsView({ view: "category" });
				
				// Now update the select list in the story form
				self.updateCategoryLists();

				self.adminAlertController.fadeOut();	

				self.updateTimelineSavedStatus({ status: "save-needed" });
			}
		}).init();
	},
	refreshUserControlsView: function(data) {
		var self = this;
		if (self.mainController.userControlsController) {
			self.mainController.userControlsController.updateView(data);	
		}
	},
	displayStandardSavingAlertMessage: function() {
		var self = this;
		self.adminAlertController.displayMessage({
			headline: TLConfigText["adminBasic_Updating"],
			hideClose: true,
			body: "<p>"+TLConfigText["adminBasic_Saving_timeline_message"]+"</p>"
		});
	},
	refreshTimelineView: function() {
		var self = this;
		self.mainController.sortMarkersByCategoryList();
		self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: self.timeline.zoom } );
		self.mainController.flushSize();
	},
	updateCategoryBand: function(data) { 
		var self = this;
		var category = data.category;
		var categoryBand = self.mainController.selectedView.categoryBandsByKey[category.key];
		categoryBand.refreshFromCategory();
	},
	initialiseTimelineList: function() {
		var self = this;
		if (self.user.timelines.length > 0) {
			self.setupTimelineList();
			if (self.timeline.id && self.user.timelinesByKey[self.timeline.id] && !self.mainController.isHomePage) {
				self.timeline.secretWord = self.user.timelinesByKey[self.timeline.id].secretWord;
				self.selectTimeline({ timeline: self.user.timelinesByKey[self.timeline.id] }); 
				self.timeline.isEditable = true;
			}
			else {
				self.helpController.setBaseHelpByName({ baseName: "timeline-list" });
			}
		}
		else {
			// We display the create timeline form
			$(self.domTimelineFormSwitch).click();	
			self.helpController.setBaseHelpByName({ baseName: "timeline-list" });
			// Hide timeline list
			$(self.domTimelineList).find(".ajk-cs-carousel").css({ display: "none" });
		}
	},
	setupTimelineList: function() {
		var self = this;
		self.timelineListController = new AJKScrollableListController({
			stagePadding: 0,
			domRoot: $(self.domTimelineList).find(".ajk-cs-carousel").get()[0],
			domStage: $(self.domTimelineList).find(".ajk-cs-carousel-stage").get()[0],
			listItems: self.user.timelines,
			createDomListItemFunc: function(data) {
				var timeline = data.listItem;				
				var insertHTML = '<div timelineId="'+timeline.id+'" class="tl-ah-list-item">';
				insertHTML+='<div class="tl-ah-col-1">';
				insertHTML+='<p id="admin-timeline-list-item-title-'+timeline.id+'">'+timeline.title+'</p>';
				insertHTML+='</div>';
				insertHTML+='<div class="tl-ah-col-2">';
				insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
				insertHTML+='</div>';
				insertHTML+='</div>';					

				return $(insertHTML).get()[0];
			},
			listItemSelectClass: "tl-ah-list-item-selected",
			itemWasClickedFunc: function(data) {
				var timeline = data.listItem;
				var clickedElClass = data.clickedElClass;

				if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
					self.adminAlertController.displayMessage({
						headline: "Delete timeline",
						body: '<p>Are you sure you want to delete this timeline. You will not be able to get the timeline back once it is deleted.</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
							action: function() {}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
							action: function() {
								// Delete the mediaitem
								self.deleteTimeline({ timelineId: timeline.id });
								self.updateTimelineList();
								self.setupTimelineList();
							}	
						}]	
					});

				}
				else {
					
					// Check to see if the selected timeline is already loaded 
					if (timeline.id == self.timeline.id && !self.mainController.isHomePage) {
						// Loaded, so simply change the class to show the timline infi
						$(self.domTimelineBlock).addClass("tl-ah-show-view-timeline-selected");
						self.helpController.setBaseHelpByName({ baseName: "default" });
					}
					else {
						// Not loaded so load
						self.mainController.loadTimeline({
							timeline: timeline
						});
					}
				}
			},
			getKeyForListItem: function(data) {
				var timeline = data.listItem;
				return timeline.id;
			},
			getPositionForListItem: function(data) {
				var timeline = data.timeline;	
				return timeline.orderIndex;
			}
		}).init();
		
		self.timelineListController.resetHeightTo({ height: self.enlargedListHeight });
	},
	setupStoriesList: function() {
		var self = this;

		self.storyListController = new AJKScrollableListController({
			stagePadding: 0,
			domRoot: $(self.domRoot).find("#tl-tab-my-selected-timeline-story-list .ajk-cs-carousel").get()[0],
			domStage: $(self.domRoot).find("#tl-tab-my-selected-timeline-story-list .ajk-cs-carousel-stage").get()[0],
			listItems: self.timeline.markers,
			createDomListItemFunc: function(data) {
				var story = data.listItem;
				var extraClass = (story.uneditable) ? " tl-ah-list-item-uneditable" : "";
		
				var insertHTML = '<div storyId="'+story.markerKey+'" class="tl-ah-list-item'+extraClass+'">';
				insertHTML+='<div class="tl-ah-col-1">';
				insertHTML+='<p id="admin-story-list-item-title-'+story.markerKey+'">'+story.headline+'</p>';
				insertHTML+='</div>';
				insertHTML+='<div class="tl-ah-col-2">';
				insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
				insertHTML+='</div>';
				insertHTML+='</div>';					
				return $(insertHTML).get()[0];
			},
			listItemSelectClass: "tl-ah-list-item-selected",
			itemWasClickedFunc: function(data) {
				var story = data.listItem;
				if (story.uneditable) {
					self.adminAlertController.displayMessage({
						headline: TLConfigText["feedStory_cantEdit_headline"],
						body: '<p>'+TLConfigText["feedStory_cantEdit_message"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
							action: function() {}	
						}]
					});
					return;	
				}
				
				var clickedElClass = data.clickedElClass;
				if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
					// delete the clickedEl;
					
					self.adminAlertController.displayMessage({
						headline: TLConfigText["story_deleteStory_headline"],
						body: '<p>'+TLConfigText["story_deleteStory_message"]+' “'+story.headline+'”?</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No'] +'</a>',
							action: function() {}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes'] +'</a>',
							action: function() {
								// Delete the story
								self.deleteStory({ story: story });
							}	
						}]	
					});
					
				}
				else {
					self.selectStory( { story: story });
				}
			},
			getKeyForListItem: function(data) {
				var story = data.listItem;
				return story.markerKey;
			},
			getPositionForListItem: function(data) {
				var story = data.listItem;	
				return story.orderIndex;
			}
		}).init();		
		
	},
	updateTimelineList: function() {
		var self = this;
		var counter = 0;
		$.each(self.user.timelines, function() {
			this.orderIndex = counter++;
		});	
	},
	deleteTimeline: function(data) {
		var self = this;
	},
	recreateInitialFocusSelect: function() {
		var self = this;
		
		var insertHTML = '<option value="first">'+TLConfigText["adminBasic_First_story"]+'</option>';
		insertHTML += '<option value="last">'+TLConfigText["adminBasic_Last_story"]+'</option>';
		insertHTML += '<option value="today">'+TLConfigText["adminBasic_Today"]+'</option>';
		
		$.each(self.timeline.markers, function() {
			if (!this.uneditable) {
				insertHTML += '<option value="'+this.id+'">'+this.headline+'</option>';
			}
		});
		$(self.domTimelineInitalFocusSelect).html(insertHTML);
		
	},
	selectTimeline: function(data) {
		var self = this;
				
		var timeline = data.timeline;

		self.recreateInitialFocusSelect();
		
		// We need to first change the admin 
		$(self.domSelectedTimelineHeadline).text(AJKHelpers.clipToMaxCharWords({ aString: timeline.title, maxChars: 30 }));
		$(self.domTimelineBlock).addClass("tl-ah-show-view-timeline-selected");	

		self.helpController.setBaseHelpByName({ baseName: "default" });

		self.setupStoriesList();
		
		self.storyListController.resetHeightTo({ height: self.enlargedListHeight });
		
		self.updateTimelineFormVerification.hideCancelButton();

		self.timelineBasicInfoPanelOpened();

		self.updateTimelineFormVerification.onChangeCallback = "";
		self.updateTimelineFormVerification.onKeyUpCallback = "";

		// We should now fill in the fields in the basic info tab
		self.updateTimelineFormVerification.setFieldValues({
			fieldValues: {
				title: self.timeline.title,
				startDate: AJKHelpers.formatDate({ formatString: "DD MMM YYYY HH:mm:ss", date: self.timeline.startDate, language: "base" }),
				endDate: AJKHelpers.formatDate({ formatString: "DD MMM YYYY HH:mm:ss", date: self.timeline.endDate, language: "base" }),
				text: self.timeline.introText,
				aboutText: self.timeline.aboutText,
				introImage: self.timeline.introImage,
				introImageDataUri: self.timeline.introImageDataUri,
				introImageCredit: self.timeline.introImageCredit,
				backgroundImage: self.timeline.backgroundImage,
				backgroundImageDataUri: self.timeline. backgroundImageDataUri,
				backgroundImageCredit: self.timeline.backgroundImageCredit,
				zoom: self.timeline.zoom,
				mainColour: self.timeline.mainColour,
				backgroundColour: self.timeline.backgroundColour,
				feed: self.timeline.feed,
				initialFocus: self.timeline.initialFocus,
				storySpacing: self.timeline.storySpacingType,
				viewType: self.timeline.viewTypeValue
			}
		});

		self.refreshTimelineZoomSelector();

		self.updateTimelineFormVerification.saveFieldValues();
		self.updateTimelineFormVerification.disableSaveAndRevert();

		self.updateTimelineFormVerification.onChangeCallback = function(data) {
			if (data.fieldName == "zoom") {
				self.zoomSelectReplacer.selectItemFromVal({ val: data.fieldValue });
				self.timeline.savedZoom = data.fieldValue;
				self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: data.fieldValue } );
				self.refreshUserControlsView({ view: "zoom" });
			}

			if (data.fieldName == "startDate" || data.fieldName == "endDate") {
				var aDate = Date.parse(data.fieldValue);
				if (self.verifyTimelineFormDate({verifier: self.updateTimelineFormVerification, date: aDate, dateType: data.fieldName})) {
					self.mainController.timeline[data.fieldName] = aDate;
					self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: "" } );
					self.refreshTimelineZoomSelector();
				}
			}
			
			if (data.fieldName == "storySpacing" && self.timeline.storySpacingType != data.fieldValue) {
				self.timeline.storySpacingType = parseInt(data.fieldValue);
				self.timeline.markerSpacing = TLViewController.markerSpacingView[self.timeline.storySpacingType].type;
				self.timeline.equalMarkerSpacing = TLViewController.markerSpacingView[self.timeline.storySpacingType].markerSpacing;
				self.timeline.markerSpacingObj = TLViewController.markerSpacingView[self.timeline.storySpacingType];
				self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: self.timeline.zoom } );
				self.hideShowZoomForSpacing();
				self.mainController.flushSize();
				self.refreshUserControlsView({ view: "spacing" });
			}
			
			if (data.fieldName == "viewType" && self.timeline.viewTypeValue != data.fieldValue) {
				self.timeline.viewTypeValue = data.fieldValue;
		 		self.timeline.viewType = self.mainController.viewTypes[data.fieldValue];
				
				if (self.timeline.viewType == "category-band") {
					self.mainController.sortMarkersByCategoryList();
				}

				self.mainController.selected3DView.clearStories3DText();
				self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: self.timeline.zoom } );
				self.mainController.flushSize();
				self.refreshUserControlsView({ view: "view" });
			}
			
			if (data.fieldName == "introImage") {
				self.updateTimelineFormVerification.setFieldValues({
					fieldValues: {
						"introImageCredit":"",
						"introImageDataUri":"",
						forceChangeEvent: true
					}	
				});
				self.mainController.aboutTimelineStory.images[0].caption = "";
				self.mainController.aboutTimelineStory.images[0].mediaDataUri = "";
				self.mainController.timeline.introImage = data.fieldValue;
				self.mainController.timeline.introImageCredit = "";
				self.mainController.timeline.introImageDataUri = "";
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "backgroundImage") {
				self.updateTimelineFormVerification.setFieldValues({
					fieldValues: {
						"backgroundImageCredit":"",
						"backgroundImageDataUri":"",
						forceChangeEvent: true
					}	
				});
				self.timeline.backgroundImageDataUri = "";
				$(self.mainController.domMainPhotoCredit).empty();
				self.mainController.timelineBackgroundImage = data.fieldValue;
				self.mainController.initialiseBackgroundImage();
			}
			
			if (data.fieldName == "backgroundImageDataUri") {
				self.timeline.backgroundImageDataUri = data.fieldValue;
				self.mainController.initialiseBackgroundImage();
			}
			
			if (data.fieldName == "introImageDataUri") {
				self.timeline.introImageDataUri = data.fieldValue;
				self.mainController.aboutTimelineStory.images[0].mediaDataUri = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "backgroundImageCredit") {
				self.mainController.timeline.backgroundImageCredit = data.fieldValue;
				$(self.mainController.domMainPhotoCredit).html(self.mainController.getBGImageCredit());
			}
			
			if (data.fieldName == "introImageCredit") {
				self.mainController.timeline.introImageCredit = data.fieldValue;
				self.mainController.aboutTimelineStory.images[0].caption = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "text") {
                self.timeline.introText = data.fieldValue;
				self.mainController.aboutTimelineStory.clippedContentIntroText = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "aboutText") {
                self.timeline.aboutText = data.fieldValue;
				self.mainController.aboutTimelineStory.fullText = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "title") {
				self.timeline.title = data.fieldValue;
				$(self.mainController.domTimelineTitle).text(data.fieldValue);
				self.mainController.aboutTimelineStory.headline = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "introImage") {
				self.mainController.aboutTimelineStory.images[0].src = data.fieldValue;
				self.updateContentPanel({ story: self.mainController.aboutTimelineStory });
			}
			
			if (data.fieldName == "backgroundColour") {
				self.timeline.backgroundColour = data.fieldValue;
				$(self.mainController.domStageHolder).css({backgroundColor: "#"+data.fieldValue });
			}

			if (data.fieldName == "mainColour") {
				// Need to update the colours of the scale blocks
				self.mainController.timeline.mainColour = data.fieldValue;
				self.mainController.selectedView.updateScaleColour({ colour: data.fieldValue });
				$.each(self.timeline.markers, function() {
					if (this.category.autoGenerated) {
						this.category.colour = data.fieldValue;
						this.categoryHasChanged();	
					}
				});	
				if (self.timeline.viewType == "category-band") {
					self.mainController.defaultCategory.colour = data.fieldValue;
					var defaultBand = self.mainController.selectedView.categoryBandsByKey[self.mainController.categoriesKeyPrefix+"default"];
					if (defaultBand) {
						defaultBand.refreshFromCategory();
					}
				}
				
			}
			
            if (data.fieldName == "initialFocus") {
                self.timeline.initialFocus = data.fieldValue;
            }

			// Event Catcher stuff
			if (self.updateTimelineFormVerification.areValuesDifferentFromSavedValues()) {
				self.eventCatcherController.activate();
			}
			else {
				self.eventCatcherController.deactivate();
			}
		}
		
		self.updateTimelineFormVerification.onKeyUpCallback = function(data) {

			if (self.updateTimelineFormVerification.areValuesDifferentFromSavedValues()) {
				self.eventCatcherController.activate();
			}
			else {
				self.eventCatcherController.deactivate();
			}
		}

	},
	verifyTimelineFormDate: function(data) {
		var self = this;
		var verifier = data.verifier;
		var aDate = data.date;
		var dateType = data.dateType;
		var newTimeline = (verifier == self.timelineFormVerification);
		if (!aDate) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["dateVerificiation_Invalid_date"],
				body: '<p>'+TLConfigText["dateVerificiation_Invalid_date_message"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				}]
			});
			verifier.restoreOldValueForField({ fieldName: dateType });
			return false;
		}
		else if (self.isEndDateBeforeStartDateForVerifier({ verifier: verifier })) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["dateVerificiation_Invalid_date"],
				body: '<p>'+TLConfigText["dateVerificiation_start_date_first_message"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				}]
			});
			verifier.restoreOldValueForField({ fieldName: dateType });
			return false;
		}
		else if (!self.isDateWithinAllowableRange({ date: aDate })) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["dateVerificiation_Invalid_date"],
				body: '<p>'+TLConfigText["dateVerificiation_outside_range_message"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				}]
			});
			verifier.restoreOldValueForField({ fieldName: dateType });
			return false;
		}
		else if (self.doesDateCutOffMarkers({ date: aDate, type: dateType }) && !newTimeline && self.timeline.feeds.length == 0) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["dateVerificiation_Story_outside_date_range"],
				body: '<p>'+TLConfigText["dateVerificiation_story_outside_range_message"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				}]
			});
			verifier.restoreOldValueForField({ fieldName: dateType });
			return false;
		}
		return true;

	},
	isEndDateBeforeStartDateForVerifier: function(data) {
		var self = this;
		var verifier = data.verifier;
		var startDate = Date.parse(verifier.getFieldValueFromName({fieldName: "startDate"}));
		var endDate = Date.parse(verifier.getFieldValueFromName({fieldName: "endDate"}));
		return startDate.getTime() > endDate.getTime();
	},
	doesDateCutOffMarkers: function(data) {
		var self = this;
		var aDate = data.date;
		var type = data.type;
		
		if (self.mainController.markers.length == 0) {
			return false;	
		}
				
		var markerLowDate = self.mainController.markers[0].startDate;
		var markerHighDate = self.mainController.markers[self.mainController.markers.length-1].startDate;

		if (type == "startDate" && aDate.getTime() > markerLowDate.getTime()) {
			return true;	
		}
		else if (type == "endDate" && aDate.getTime() < markerHighDate.getTime()) {
			return true;
		}
		else {
			return false;
		}
	},
	isDateWithinAllowableRange: function() {
		var self = this;
		
		// This will check whether a date is within an allowable range
		return true;	
	},
	createMediaItemTitle: function(data) {
		var self = this;	
		var mediaItem = data.mediaItem;
		var srcSplit = mediaItem.src.split("/");
		var srcBits = srcSplit.length;
		
		var srcText = (srcBits == 1) ? srcSplit[0] : srcSplit[srcBits-2]+"/"+srcSplit[srcBits-1];
		var maxSrcLength = 20;
		if (srcText.length > maxSrcLength) {
			var startPos = srcText.length-maxSrcLength;
			srcText = srcText.substr(startPos, srcText.length-1)
		}
		
		var titleText = "("+mediaItem.type+") "+srcText;
		return titleText; 
	},
	setupStoryMediaList: function() {
		var self = this;
		

		var lastSelectedStory = "";
		$(self.domStoryMediaMenuButton).click( function() {
			if (lastSelectedStory == self.selectedStory) {
				return;	
			}
			lastSelectedStory = self.selectedStory;
			 
			if (!self.storyMediaListController) {
				self.storyMediaListController = new AJKScrollableListController({
					stagePadding: 0,
					domRoot: $(self.domRoot).find("#tl-tab-selected-story-extra-media .ajk-cs-carousel").get()[0],
					domStage: $(self.domRoot).find("#tl-tab-selected-story-extra-media .ajk-cs-carousel-stage").get()[0],
					listItems: self.selectedStory.media,
					createDomListItemFunc: function(data) {
						var mediaItem = data.listItem;				
						var insertHTML = '<div mediaId="'+mediaItem.id+'" class="tl-ah-list-item">';
						insertHTML+='<div class="tl-ah-col-1">';
						insertHTML+='<p id="tl-media-item-'+mediaItem.id+'">'+self.createMediaItemTitle({mediaItem: mediaItem })+'</p>';
						insertHTML+='</div>';
						insertHTML+='<div class="tl-ah-col-2">';
						insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
						insertHTML+='</div>';
						insertHTML+='</div>';					
						return $(insertHTML).get()[0];
					},
					listItemSelectClass: "tl-ah-list-item-selected",
					itemWasClickedFunc: function(data) {
						var mediaItem = data.listItem;
						var clickedElClass = data.clickedElClass;
						if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
							// delete the clickedEl;
							
							self.adminAlertController.displayMessage({
								headline: TLConfigText["media_deleteMedia_headline"],
								body: '<p>'+TLConfigText["media_deleteMedia_message"]+' “'+self.createMediaItemTitle({mediaItem: mediaItem })+'”?</p>',
								buttons: [{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
									action: function() {}	
								},{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
									action: function() {
										// Delete the mediaitem
										self.deleteMediaItem({ mediaItem: mediaItem });
									}	
								}]	
							});
							
						}
						else {
							self.selectMediaItem( { mediaItem: mediaItem });
						}
					},
					getKeyForListItem: function(data) {
						var mediaItem = data.listItem;
						return mediaItem.id;
					},
					getPositionForListItem: function(data) {
						var mediaItem = data.listItem;	
						return mediaItem.listPosition;
					}
				}).init();
			}
			else {
				
				self.storyMediaListController.resetWithNewListItems({
					listItems: self.selectedStory.media
				});
		
			}
		});
		
		
	},
	setupCategoryList: function() {
		var self = this;
		
		$("#tl-categories-tab-menu-item").click( function() {
			if (!self.categoriesListController) {
				self.categoriesListController = new AJKScrollableListController({
					stagePadding: 0,
					domRoot: $(self.domRoot).find("#tab-my-selected-timeline-categories .ajk-cs-carousel").get()[0],
					domStage: $(self.domRoot).find("#tab-my-selected-timeline-categories .ajk-cs-carousel-stage").get()[0],
					listItems: self.getCategories(),
					createDomListItemFunc: function(data) {
						var categoryItem = data.listItem;				
						var extraClass = (categoryItem.uneditable) ? " tl-ah-list-item-uneditable" : "";
						var insertHTML = '<div categoryId="'+categoryItem.id+'" class="tl-ah-list-item'+extraClass+'">';
						insertHTML+='<div class="tl-ah-col-1">';
						insertHTML+='<p id="tl-category-item-'+categoryItem.id+'">'+categoryItem.title+'</p>';
						insertHTML+='</div>';
						insertHTML+='<div class="tl-ah-col-2">';
						insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
						insertHTML+='</div>';
						insertHTML+='</div>';					
						return $(insertHTML).get()[0];
					},
					listItemSelectClass: "tl-ah-list-item-selected",
					itemWasClickedFunc: function(data) {
						var categoryItem = data.listItem;

						if (categoryItem.uneditable) {
							self.adminAlertController.displayMessage({
								headline: TLConfigText["feedCategory_cantEdit_headline"],
								body: '<p>'+TLConfigText["feedCategory_cantEdit_message"]+'</p>',
								buttons: [{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
									action: function() {}	
								}]
							});
							return;	
						}

						var clickedElClass = data.clickedElClass;
						if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
							// delete the clickedEl;

							self.adminAlertController.displayMessage({
								headline: TLConfigText["category_deleteCategory_headline"],
								body: '<p>'+TLConfigText["category_deleteCategory_message"]+' “'+categoryItem.title+'”?</p>',
								buttons: [{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
									action: function() {}	
								},{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
									action: function() {
										// Delete the story
										self.deleteCategoryItem({ categoryItem: categoryItem });
									}	
								}]	
							});

						}
						else {
							self.selectCategoryItem( { categoryItem: categoryItem });
						}
					},
					getKeyForListItem: function(data) {
						var categoryItem = data.listItem;
						return categoryItem.id;
					},
					getPositionForListItem: function(data) {
						var categoryItem = data.listItem;	
						return categoryItem.listPosition;
					}
				}).init();
			}
		});
		
		
	},
	createNewCategoryItem: function() {
		var self = this;
		var newCategoryItem = {
			id: "awaitingId",
			title: TLConfigText["category_New_category"],
			colour: self.mainController.timeline.mainColour,
			order: 10,
			size: 10,
			layout: 0,
			rows: 3
		}	
		self.categoriesListController.addListItemAtIndex({
			listItem: newCategoryItem,
			index: "last"
		});
		self.categoriesListController.showAndSelectListItem({ listItem: newCategoryItem });
		self.selectCategoryItem({ categoryItem: newCategoryItem });
	},
	deleteCategoryItem: function(data) {
		var self = this;

		var categoryItem = data.categoryItem;
		self.categoriesListController.removeListItem({
			listItem: categoryItem
		});

		var vars = {};
		vars["id"] = categoryItem.id;
		vars["timelineId"] = self.timeline.id;
		
		self.updateContentPanel({ story: self.selectedStory });
		setTimeout( function() {
			if (self.timeline.viewType == "category-band") {
				self.refreshTimelineView();
			}
		},1);
						
		self.timeline.categories = AJKHelpers.removeItemFromArray({anArray: self.timeline.categories, item: categoryItem });

		self.updateCategoryLists();

		if (self.selectedCategoryItem == categoryItem) {
			self.hideCategoriesForm();
			self.selectedCategoryItem = "";
		}
		
		self.categoriesHaveChanged();
		self.eventCatcherController.deactivate();
		
		// Need to deal with stories that are of this category
		$.each(self.mainController.markers, function() {
			if (this.category == categoryItem) {
				this.category = self.mainController.defaultCategory;
				this.clear3DText();	
			}
		});
		
		self.refreshUserControlsView({ view: "category" });
		self.updateTimelineSavedStatus({ status: "save-needed" });
		self.mainController.selected3DView.redisplay();
	},
	categoriesHaveChanged: function() {
		var self = this;
		self.categoriesListController.resetWithNewListItems({ listItems: self.getCategories() });
		
	},
	getCategories: function() {
		var self = this;
		var retArray = [];
		$.each( self.timeline.categories, function() {
			if (!this.autoGenerated) {
				retArray.push(this);	
			}
		});
		return retArray;
	},
	createNewMediaItem: function() {
		var self = this;
		var newMediaItem = self.selectedStory.createNewMediaItem();	
		self.storyMediaListController.addListItemAtIndex({
			listItem: newMediaItem,
			index: "last"
		});
		self.storyMediaListController.showAndSelectListItem({ listItem: newMediaItem });
		self.selectMediaItem( { mediaItem: newMediaItem });
	},
	deleteMediaItem: function(data) {
		var self = this;
		var mediaItem = data.mediaItem;
		self.storyMediaListController.removeListItem({
			listItem: mediaItem
		});
		self.selectedStory.deleteMediaItem({ mediaItem: mediaItem });

		if (self.selectedMediaItem == mediaItem) {
			self.hideStoryMediaForm();
			self.selectedMediaItem = "";
		}

		self.updateContentPanel({ story: self.selectedStory });
		self.eventCatcherController.deactivate();
		self.updateTimelineSavedStatus({ status: "save-needed" });
	},
	deleteStory: function(data) {
		// Note this does not delete a story from the database only from appearing in admin and on the timeline
		var self = this;
		var story = data.story;
		self.storyListController.removeListItem({
			listItem: story
		});
		self.mainController.deleteMarker({ marker: story });
		if (self.selectedStory == story) {
			self.hideStoryForm();
			self.selectedStory = "";
		}
		self.updateContentPanel({deletedStory: story, story: story });
		self.eventCatcherController.deactivate();
		self.mainController.selected3DView.redisplayAfterDataChange();
		if (self.timeline.viewType == "category-band") {
			self.refreshTimelineView();			
		}
		self.updateTimelineSavedStatus({ status: "save-needed" });
	},
	createNewStory: function() {
		var self = this;
		var newStory = self.mainController.createNewMarker();	
		self.storyListController.addListItemAtIndex({
			listItem: newStory,
			index: newStory.orderIndex
		});
		self.mainController.selected3DView.redisplayAfterDataChange();
		self.selectStory( { story: newStory, isNewStory: true });
	},
	minimiseStoryBlock: function(data) {
		var self = this;
		var dontDeselectItem = (data && data.dontDeselectItem);
		$(self.domStoryBasicInfoTabButton).click();
		self.hideStoryForm();
		self.storyListController.resetHeightTo({ height: self.enlargedListHeight });
		self.helpController.setBaseHelpByName({ baseName: "default" });
		if (dontDeselectItem && self.selectedStory) {
			self.storyListController.showAndSelectListItem({ listItem: self.selectedStory, instantly: true });
		}
		else {
			self.storyListController.deselectSelectedListItem();
		}
		
		self.selectedStory = false;
	},
	hideStoryForm: function() {
		var self = this;
		//tl-block-selected-timeline-story
		$(self.domSelectedTimelineStoryTab).removeClass("tl-ah-show-view-timeline-story-selected");	
	},
	hideStoryMediaForm: function() {
		var self = this;		
		$(self.domStoryMediaTab).removeClass("tl-ah-show-view-media-story-selected");	
	},
	hideCategoriesForm: function() {
		var self = this;		
		$(self.domCategoriesForm).css({ display: "none" });
	},
	timelineBasicInfoPanelOpened: function() {
		var self = this;
		self.eventCatcherController.setupAction({
			domCutOffEl: self.domUpdateTimelineForm,
			clickFunc: function() {
				self.adminAlertController.displayMessage({
					headline: TLConfigText["timelineForm_unsavedChanges_headline"],
					body: '<p>'+TLConfigText["timelineForm_unsavedChanges_message"]+'</p>',
					buttons: [{
						html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
						action: function() {
							// Save the story
							self.updateTimelineFormVerification.fireButton({ buttonType: "save" });
						}	
					},{
						html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
						action: function() {
							// Revert the story
							self.updateTimelineFormVerification.fireButton({ buttonType: "revert" });
						}	
					}]
				});
			}
		});
	},
	categoryPanelOpened: function() {
		var self = this;
		self.eventCatcherController.setupAction({
			domCutOffEl: self.domCategoriesForm,
			clickFunc: function() {
				if (self.selectedCategoryItem.id != "awaitingId") { // Existing category
					self.adminAlertController.displayMessage({
						headline: TLConfigText["category_unsavedChanges_headline"],
						body: '<p>'+TLConfigText["category_unsavedChanges_message1"]+' “'+self.selectedCategoryItem.title+'”. '+TLConfigText["category_unsavedChanges_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.categoriesFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
							action: function() {
								// Revert the story
								self.categoriesFormVerifier.fireButton({ buttonType: "revert" });
							}	
						}]	
					});
				}
				else { // New category
					self.adminAlertController.displayMessage({
						headline: TLConfigText["category_unsavedCategory_headline"],
						body: '<p>'+TLConfigText["category_unsavedCategory_message1"]+' “'+self.selectedCategoryItem.title+'”. '+TLConfigText["category_unsavedCategory_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.categoriesFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Delete']+'</a>',
							action: function() {
								// Cancel the new story
								self.categoriesFormVerifier.fireButton({ buttonType: "cancel" });
							}	
						}]	
					});
				}
				
			}
		});

	},
	selectCategoryItem: function(data) {
		var self = this;
		var categoryItem = data.categoryItem;
		var oldCategoryItem = self.selectedCategoryItem;
		self.selectedCategoryItem = categoryItem;
		self.categoriesListController.selectListItem({ listItem: categoryItem });
		
		self.categoryPanelOpened();
		
		if (self.selectedCategoryItem != oldCategoryItem) {
			$(self.domSelectedCategoryTitle).text(self.selectedCategoryItem.title);
			$(self.domCategoriesForm).css({ display: "block" });
			self.categoriesFormVerifier.onChangeCallback = "";
			self.categoriesFormVerifier.onKeyUpCallback = "";

			self.categoriesFormVerifier.setFieldValues({
				fieldValues: {
					title: categoryItem.title,
					colour: categoryItem.colour,
					order: categoryItem.order,
					size: categoryItem.size,
					layout: categoryItem.layout,
					rows: categoryItem.rows
				}
			});

			if (self.selectedCategoryItem.id != "awaitingId") {
				self.categoriesFormVerifier.hideCancelButton();
				self.categoriesFormVerifier.showRevertButton();
				self.categoriesFormVerifier.disableSaveAndRevert();
				self.categoriesFormVerifier.saveFieldValues();
			}
			else {
				// Category has no ID so has not been saved yet so we display the cancel rather than the revert button
				self.categoriesFormVerifier.hideRevertButton();
				self.categoriesFormVerifier.showCancelButton();
				self.categoriesFormVerifier.enableSaveAndRevert();
				self.eventCatcherController.activate();
			}

			self.categoriesFormVerifier.onChangeCallback = function(data) {
				self.updateCategoryValue(data);
				if (self.categoriesFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}
			self.categoriesFormVerifier.onKeyUpCallback = function(data) {
				if (data.fieldName == "title") {
					self.updateCategoryValue(data);
				}
				if (self.categoriesFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}

		}
	},
	storyBasicInfoPanelOpened: function() {
		var self = this;
		self.lastOpenedSectionTab["section-story"] = "story-basic-info";
		self.eventCatcherController.setupAction({
			domCutOffEl: self.domStoryForm,
			clickFunc: function() {
				if (self.selectedStory.id) { // Existing story
					self.adminAlertController.displayMessage({
						headline: TLConfigText["story_unsavedChanges_headline"],
						body: '<p>'+TLConfigText["story_unsavedChanges_message1"]+' “'+self.selectedStory.headline+'”. '+TLConfigText["story_unsavedChanges_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.storyFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
							action: function() {
								// Revert the story
								self.storyFormVerifier.fireButton({ buttonType: "revert" });
							}	
						}]	
					});
				}
				else { // New story
					self.adminAlertController.displayMessage({
						headline: TLConfigText["story_unsavedStory_headline"],
						body: '<p>'+TLConfigText["story_unsavedStory_message1"]+' “'+self.selectedStory.headline+'”. '+TLConfigText["story_unsavedStory_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.storyFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Delete']+'</a>',
							action: function() {
								// Cancel the new story
								self.storyFormVerifier.fireButton({ buttonType: "cancel" });
							}	
						}]	
					});
				}
				
			}
		});
	},
	selectStory: function(data) {
		var self = this;
		var story = data.story;
		var oldStory = self.selectedStory;
		var cancelCentering = (data && data.cancelCentering) ? true : false;
		self.selectedStory = story;

		$(self.domStoryBasicInfoTabButton).click();
		self.storyBasicInfoPanelOpened();

		if (story == oldStory) {
			//return false;	
		}

		$(self.domSelectedTimelineStoryTab).addClass("tl-ah-show-view-timeline-story-selected");
		self.storyListController.resetHeightTo({ height: self.reducedListHeight });
		
		if (!cancelCentering) {
			self.mainController.focusMarker({ marker: story });
		}
			
		self.storyListController.showAndSelectListItem({ listItem: self.selectedStory, instantly: true });

		setTimeout( function() {
			self.helpController.setBaseHelpByName({ baseName: "selected-story" });
		},1);
		
		if (self.selectedStory != oldStory) { 
	
	
			if (self.contentPanelController.panelVisible) {
				self.contentPanelController.displayForStory({ story: self.selectedStory });
			}
			
			$(self.domSelectedStoryHeadline).text(story.headline);
			
			// We need to select any media items and focus on the basic info tab for the story
			$(self.domStoryMediaTab).removeClass("tl-ah-show-view-media-story-selected");	
			self.selectedMediaItem = "";

			self.storyFormVerifier.onChangeCallback = "";
			self.storyFormVerifier.onKeyUpCallback = "";

			self.storyFormVerifier.setFieldValues({
				fieldValues: {
					title: story.headline,
					startDate: AJKHelpers.formatDate({
						formatString: "DD MMM YYYY HH:mm:ss",
						date: story.startDate,
						language: "base"
					}),
					endDate: AJKHelpers.formatDate({
						formatString: "DD MMM YYYY HH:mm:ss",
						date: story.endDate,
						language: "base"
					}),
					fullText: story.fullText,
					text: story.introText,
					category: story.category.id,
					externalLink: story.externalLink,
					dateFormat: story.dateFormat
				}
			});
			
			if (self.selectedStory.id) {
				self.storyFormVerifier.hideCancelButton();
				self.storyFormVerifier.showRevertButton();
				self.storyFormVerifier.disableSaveAndRevert();
				self.storyFormVerifier.saveFieldValues();
			}
			else {
				// Story has no ID so has not been saved yet so we display the cancel rather than the revert button
				self.storyFormVerifier.hideRevertButton();
				self.storyFormVerifier.showCancelButton();
				self.storyFormVerifier.enableSaveAndRevert();
				self.eventCatcherController.activate(); // Catch click away events because new story and not saved
			}
						
			var updateStoryFormEventCatcher = function() {
				if (self.storyFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}
			// We need functions for observing every change - ie title
			// And for the onChange event - ie images 
			self.storyFormVerifier.onChangeCallback = function(data) {
				if (data.fieldName == "startDate") {
					var oldStoryDate = new Date();
					oldStoryDate.setTime(story.startDate.getTime());
					var startDate = Date.parse(data.fieldValue);
					if (!self.isStoryStartDateInTimelineRange({ startDate: startDate })) {
						return;	
					}
					self.updateStoryValue(data);
					updateStoryFormEventCatcher();
					self.syncStoryStartEndDates({ oldStoryStartDate: oldStoryDate });					
					self.mainController.sortMarkersList();
					self.storyListController.resetWithNewListItems({ listItems: self.timeline.markers });
					self.storyListController.showAndSelectListItem({ listItem: story, instantly: true });
					self.mainController.updateMarkersImageSize();
				}
				else {
					// Default action
					self.updateStoryValue(data);
					updateStoryFormEventCatcher();
				}

				if (data.fieldName == "category" && self.timeline.viewType == "category-band") {
					self.refreshTimelineView();
				}
			}
			
			self.storyFormVerifier.onKeyUpCallback = function(data) {
				if (data.fieldName == "title" || data.fieldName == "text") {
					self.updateStoryValue(data);
				} 
				updateStoryFormEventCatcher();
			}

			// Tag initialisation stuff on story select
			
			self.adminTagController.storyWasSelected();
			
			
		}

		return true;
	},
	syncStoryStartEndDates: function(data) {
		var self = this;
		var oldStoryStartDate = data.oldStoryStartDate;
		var startDate = Date.parse(self.storyFormVerifier.getFieldValueFromName({ fieldName: "startDate" }));
		var endDate = Date.parse(self.storyFormVerifier.getFieldValueFromName({ fieldName: "endDate" }));
		if (!startDate || !endDate) {
			return;	
		}
		if (endDate.getTime() < startDate.getTime() || endDate.getTime() == oldStoryStartDate.getTime()) {
			var newEndDate = AJKHelpers.formatDate({
				formatString: "DD MMM YYYY HH:mm:ss",
				date: startDate,
				language: "base"
			});
			if (endDate.getTime() != startDate.getTime()) {
				self.storyFormVerifier.setFieldValues({
					fieldValues: {
						endDate: newEndDate
					},
					forceChangeEvent: true
				});
			}
		}
	},
	isStoryStartDateInTimelineRange: function(data) {
		var self = this;
		var startDate = data.startDate;
		
		if (!startDate) {
			return false;	
		}
		if (!self.isDateWithinAllowableRange({ date: startDate })) {
			// Not an allowable date so restoreDateToPrevValue
			self.adminAlertController.displayMessage({
				headline: TLConfigText["storyDate_outsideTimeline_headline"],
				body: "<p>"+TLConfigText["storyDate_outsideTimeline_message"]+"</p>",
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {
						self.storyFormVerifier.restoreOldValueForField({ fieldName: "startDate" });
					}
				}]
			});
			return false;
		}
		else if (startDate.getTime() < self.timeline.startDate.getTime() || startDate.getTime() > self.timeline.endDate.getTime()) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["storyDate_outsideTimeline2_headline"],
				body: TLConfigText["storyDate_outsideTimeline2_message"],
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
					action: function() {
						if (startDate.getTime() < self.timeline.startDate.getTime()) {
							self.timeline.startDate = startDate;
							self.updateTimelineFormVerification.setFieldValues({
								forceChangeEvent: true,
								fieldValues: {
									startDate: AJKHelpers.formatDate({ 
										formatString: "DD MMM YYYY HH:mm:ss", 
										date: self.timeline.startDate,
										language: "base"
									})
								}
							});
						}
						else {
							self.timeline.endDate = startDate;
							self.updateTimelineFormVerification.setFieldValues({
								forceChangeEvent: true,
								fieldValues: {
									endDate: AJKHelpers.formatDate({ 
										formatString: "DD MMM YYYY HH:mm:ss", 
										date: self.timeline.endDate,
										language: "base"
									})
								}
							});
						}
						self.updateTimelineFormVerification.fireButton({ buttonType: "save" });

						self.refreshTimelineZoomSelector();
						// Now need to save the actual timeline with new date range and maybe the story too.
						self.updateStoryValue({
							fieldName: "startDate",
							fieldValue: AJKHelpers.formatDate({ 
								formatString: "DD MMM YYYY HH:mm:ss", 
								date: startDate,
								language: "base"
							})
						});
						self.storyFormVerifier.fireButton({ buttonType: "save" });

						self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: self.timeline.zoom } );
						//updateStoryFormEventCatcher();
					}	
				},{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
					action: function() {
						self.storyFormVerifier.restoreOldValueForField({ fieldName: "startDate" });
						
						if (!self.storyFormVerifier.areValuesDifferentFromSavedValues()) {
							self.eventCatcherController.deactivate();
						}
					}	
				}]
			}); 
			return false;
		}
		return true;
	},
	storyMediaPanelOpened: function() {
		var self = this;
		self.eventCatcherController.setupAction({
			domCutOffEl: self.domStoryMediaForm,
			clickFunc: function() {
				if (self.selectedMediaItem.id != "awaitingId") { // Existing story
					self.adminAlertController.displayMessage({
						headline: TLConfigText["storyMedia_unsavedChanges1_headline"],
						body: '<p>'+TLConfigText["storyMedia_unsavedChanges1_message1"]+' “'+self.createMediaItemTitle({mediaItem: self.selectedMediaItem })+'”. '+TLConfigText["storyMedia_unsavedChanges1_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.storyMediaFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
							action: function() {
								// Revert the story
								self.storyMediaFormVerifier.fireButton({ buttonType: "revert" });
							}	
						}]	
					});
				}
				else { // New story
					self.adminAlertController.displayMessage({
						headline: TLConfigText["storyMedia_unsavedChanges2_headline"],
						body: '<p>'+TLConfigText["storyMedia_unsavedChanges2_message1"] +' “'+self.createMediaItemTitle({mediaItem: self.selectedMediaItem })+'”. '+TLConfigText["storyMedia_unsavedChanges2_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the story
								self.storyMediaFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Delete']+'</a>',
							action: function() {
								// Cancel the new story
								self.storyMediaFormVerifier.fireButton({ buttonType: "cancel" });
							}	
						}]	
					});
				}
				
			}
		});
	},
	loadMediaThumb: function(data) {
		var self = this;
		var mediaItem = data.mediaItem;
		var thumbImage = AJKHelpers.getMediaImageUri({ media:mediaItem });
		$(self.domStoryMediaThumb).empty();
		if (thumbImage && thumbImage != TLConfigText['marker_media_Enter_meda_source_here']) {
			new AJKImageLoader({
				imageUrl: thumbImage,
				loadCallback: function(data) {
					if (self.selectedMediaItem == mediaItem) {
						var domImage = data.image;
						$(self.domStoryMediaThumb).empty().append(domImage);
						AJKHelpers.sizeImageToFitInBoxOfSize({
							domImage: domImage,
							boxSize: {
								width: 30,
								height: 30
							},
							imageOffset: mediaItem.thumbPosition
						});
					}
				} 
			}).init();
		}
	},
	selectMediaItem: function(data) {
		var self = this;
		var mediaItem = data.mediaItem;
		var oldMediaItem = self.selectedMediaItem;
		self.selectedMediaItem = mediaItem;
		self.storyMediaListController.selectListItem({ listItem: mediaItem });

		if (mediaItem.type == "Image") {
			$(self.domStoryMediaForm).find("#tl-ah-media-source-field").removeClass("tl-ah-image-field-hide-button");
			$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "none" });
		}
		else if (mediaItem.type == "Map") {
			$(self.domStoryMediaForm).find("#tl-ah-media-source-field").addClass("tl-ah-image-field-hide-button");
			$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "none" });
		}
		else { // Audio or video item
			$(self.domStoryMediaForm).find("#tl-ah-media-source-field").addClass("tl-ah-image-field-hide-button");
			$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "block" });
		}

		if (self.selectedMediaItem != oldMediaItem) {						
			$(self.domSelectedStoryMediaHeadline).text(self.createMediaItemTitle({mediaItem: self.selectedMediaItem }));
			$(self.domStoryMediaTab).addClass("tl-ah-show-view-media-story-selected");	

			self.loadMediaThumb({
				mediaItem: mediaItem
			});
			
			self.storyMediaFormVerifier.onChangeCallback = "";
			self.storyMediaFormVerifier.onKeyUpCallback = "";

			self.storyMediaFormVerifier.setFieldValues({
				fieldValues: {
					type: mediaItem.type,
					orderIndex: mediaItem.orderIndex,
					src: mediaItem.src,
					caption: mediaItem.caption,
					video_thumb: (mediaItem.type == "Image") ? "" : mediaItem.externalMediaThumb,
					thumbPosition: mediaItem.thumbPosition,
					mediaDataUri: mediaItem.mediaDataUri,
                    bookmarkData: mediaItem.bookmarkData
				}
			});

			if (self.selectedMediaItem.id != "awaitingId") {
				self.storyMediaFormVerifier.hideCancelButton();
				self.storyMediaFormVerifier.showRevertButton();
				self.storyMediaFormVerifier.disableSaveAndRevert();
				self.storyMediaFormVerifier.saveFieldValues();
			}
			else {
				// Media has no ID so has not been saved yet so we display the cancel rather than the revert button
				self.storyMediaFormVerifier.hideRevertButton();
				self.storyMediaFormVerifier.showCancelButton();
				self.storyMediaFormVerifier.enableSaveAndRevert();
				self.eventCatcherController.activate(); // Catch click away events because new media and not saved
				self.storyMediaFormVerifier.clearSavedFieldValues();
			}

			self.storyMediaFormVerifier.onChangeCallback = function(data) {
				self.updateMediaValue(data);
				if (self.storyMediaFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}

				if (data.fieldName == "src" && self.selectedMediaItem.type == "Image") {
                    self.selectedMediaItem.mediaDataUri = "";
                    self.storyMediaFormVerifier.setFieldValues({
                        fieldValues: {
                            mediaDataUri: ""
                        }
                    });
                }
                
                if ((data.fieldName == "src" || data.fieldName == "mediaDataUri") && self.selectedMediaItem.type == "Image") {
					self.loadMediaThumb({
						mediaItem: self.selectedMediaItem
					});
				}

				if (data.fieldName == "video_thumb" && (self.selectedMediaItem.type == "Video" || self.selectedMediaItem.type == "Audio")) {
                    self.selectedMediaItem.mediaDataUri = "";
                    self.storyMediaFormVerifier.setFieldValues({
                        fieldValues: {
                            mediaDataUri: ""
                        }
                    });

					self.selectedMediaItem.externalMediaThumb = data.fieldValue;
					self.loadMediaThumb({
						mediaItem: self.selectedMediaItem
					});
					self.selectedStory.mediaHasBeenUpdated();
				}

                if (data.fieldName == "bookmarkData") {
                    self.selectedMediaItem.bookmarkData = data.fieldValue;
                }
                
				if (data.fieldName == "type" && data.fieldValue == "Image") {
					$(self.domStoryMediaForm).find("#tl-ah-media-source-field").removeClass("tl-ah-image-field-hide-button");
					$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "none" });
				}
				else if (data.fieldName == "type" && (data.fieldValue == "Map")) {
					$(self.domStoryMediaForm).find("#tl-ah-media-source-field").addClass("tl-ah-image-field-hide-button");
					$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "none" });
				}
				else if (data.fieldName == "type" && (data.fieldValue == "Video" || data.fieldValue == "Audio")) {
					$(self.domStoryMediaForm).find("#tl-ah-media-source-field").addClass("tl-ah-image-field-hide-button");
					$(self.domStoryMediaForm).find("#tl-ah-video-thumb-field").css({ display: "block" });
                    self.storyMediaFormVerifier.setFieldValues({
                        forceChangeEvent: true,
                        fieldValues: {
                            mediaDataUri: ""
                        }
                    });
				}

			}
			
			self.storyMediaFormVerifier.onKeyUpCallback = function(data) {
				if (data.fieldName == "caption") {
					self.updateMediaValue(data);
				} 
				if (self.storyMediaFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}


		}
	},
	updateCategoryValue: function(data) {
		var self = this;
		var fieldName = data.fieldName;
		var fieldValue = data.fieldValue;
		self.selectedCategoryItem[fieldName] = fieldValue;

		if (fieldName == "title") {
			$(self.domSelectedCategoryTitle).text(self.selectedCategoryItem.title);
			$("#tl-category-item-"+self.selectedCategoryItem.id).text(self.selectedCategoryItem.title);
		}
	},
	updateMediaValue: function(data) {
		//$(theTLParantWindow.document).find("#console").append("<span>"+data.fieldName+"</span>");
		var self = this;
		var fieldName = data.fieldName;
		var fieldValue = data.fieldValue;
		self.selectedMediaItem[fieldName] = fieldValue;
		
		var itemTitle = self.createMediaItemTitle({mediaItem: self.selectedMediaItem });
		
		$(self.domSelectedStoryMediaHeadline).text(itemTitle);

		self.selectedStory.mediaHasBeenUpdated();
		
		if (fieldName == "src" || fieldName == "type") {
			$("#tl-media-item-"+self.selectedMediaItem.id).text(itemTitle);
			//self.selectedStory.updateDisplayImage();
		}

	},
	updateStoryValue: function(data) {
		var self = this;
		var fieldName = data.fieldName;
		var fieldValue = data.fieldValue;
		switch(fieldName) {
			case "title":
			self.selectedStory.setValue({
				valueName: "headline",
				value: fieldValue
			});

			var titleText = AJKHelpers.prepareGTLTForText({ content: self.selectedStory.headline });

			$(self.domSelectedStoryHeadline).text(titleText);
			
			$("#admin-story-list-item-title-"+self.selectedStory.markerKey).text(titleText);
			break;	
			case "text":
			self.selectedStory.setValue({
				valueName: "introText",
				value: fieldValue
			});
			break;	
			case "startDate":
			// We really need to check here whether the date is valid and also whether it is within range
			// Display an error meesage if it isn't either and revert on closure of the message
			// Also if the new dates falls outside the range of the timeline, then we need to
			// ask whether to stretch the timeline range to include the new date, or cancel 
			// I THINK THIS IS ALREADY DONE ELSEWHERE
			self.selectedStory.setValue({
				valueName: "startDate",
				value: Date.parse(fieldValue)
			});
			break;	
			case "endDate":
			self.selectedStory.setValue({
				valueName: "endDate",
				value: Date.parse(fieldValue)
			});
			break;	
			default:
			self.selectedStory.setValue({
				valueName: fieldName,
				value: fieldValue
			});
			break;
		}
	},
	updateContentPanel: function(data) {
		var self = this;
		var forceUpdate = (data) ? data.forceUpdate : false;
		var storyDeleted = (data) ? data.storyDeleted : false;
		var story = data.story;
		if (storyDeleted && self.contentPanelController.panelVisible && storyDeleted == self.contentPanelController.selectedStory) {
			self.contentPanelController.hide();
		}
		else if (self.contentPanelController.panelVisible && (story == self.contentPanelController.selectedStory || forceUpdate)) {
			self.mainController.contentPanelController.displayForStory({ story: story, cancelGalleryTransition: true });
		}
		
	},
	refreshStoryPositions: function() {
		var self = this;
		var selectedView = self.mainController.selectedView;
		selectedView.generateMarkerSizeAndPositions();
		selectedView.refreshDisplayMarkers();	
	},
	createFieldHTML: function() {
		var self = this;
		var insertHTML = '<div class="tl-ah-input">';
		insertHTML += '<div class="tl-ah-f-inner">';
		insertHTML += '<input class="ajk-verifier-control" value="" />';
		insertHTML += '</div>';
		insertHTML += '<div class="tl-ah-f-right"></div>';
		return insertHTML;
	},
	setupEmbed: function() {
		var self = this;
		
		var domEmbedTabButton = $(self.domRoot).find("#tl-ah-embed-timeline").get()[0];
		
		if (self.mainController.user.accountType == "Standard") {
			$(domEmbedTabButton).click( function() {
				//self.promotionPanel.show({oneOffClass: "tl-pp-show-account-message-"+self.mainController.user.accountType.toLowerCase()});
				return false;	
			});
		}
		else {
			var embedLightbox = "";
			var domEmbedContent = $("#tl-ah-embed-form").get()[0];
			$(domEmbedTabButton).click( function() {
				// Need to show the lightbox here
				if (!embedLightbox) {
					embedLightbox = new TLAdminLightbox({
						domClass: "tl-ah-embed-lightbox",
						title: TLConfigText["embed_title"],
						intro: "",
						domContent: domEmbedContent
					}).init();	
				} 
				embedLightbox.openPanel();
				return false;
			});
						
			var previewEmbed = "";
			self.embedVerifier = new AJKVerifier({
				domRootEl: domEmbedContent,
				submitFunc: function(data) { 
					window.open(previewEmbed);
				}
			}).init();
			
			self.embedVerifier.onKeyUpCallback = function(data) {
				var embHeight = self.embedVerifier.getFieldValueFromName({ fieldName: "height" });	
				var embWidth = self.embedVerifier.getFieldValueFromName({ fieldName: "width" });
				var embSrc = 'http://'+self.timeline.host+'/timeline/embed/'+self.timeline.id+'/'+self.timeline.embedHash+'/';
				previewEmbed = 'http://'+self.timeline.host+'/previewembed/entry/'+self.timeline.id+'/'+self.timeline.embedHash+'/'+embWidth+'/'+embHeight+'/';
	
				var embedCode = '<iframe onmousewheel="" frameborder="0" style="border-width:0;" id="tl-timeline-iframe" width="'+embWidth+'" height="'+embHeight+'" src="'+embSrc+'"></iframe>'+"\n";
				embedCode+='<script type="text/javascript">'+"\n";
				embedCode+='if (window.postMessage) {'+"\n";
				embedCode+='var tlMouseupFunc = function() {'+"\n";
				embedCode+='var tlFrame = document.getElementById("tl-timeline-iframe");'+"\n";
				embedCode+='if (tlFrame.contentWindow && tlFrame.contentWindow.postMessage) {'+"\n";
				embedCode+='tlFrame.contentWindow.postMessage("mouseup","*");'+"\n";
				embedCode+='}'+"\n"; 
				embedCode+='}'+"\n";
				embedCode+='if (typeof window.addEventListener != "undefined") {'+"\n";  
				embedCode+='window.addEventListener("mouseup", tlMouseupFunc, false);'+"\n";  
				embedCode+='}'+"\n";
				embedCode+='else if (typeof window.attachEvent != "undefined") {'+"\n";  
				embedCode+='window.attachEvent("onmouseup", tlMouseupFunc);'+"\n";  
				embedCode+='}'+"\n";
				embedCode+='}'+"\n";
				embedCode+='</script>'+"\n";
				
				self.embedVerifier.setFieldValues({
					fieldValues: {
						"embed": embedCode				
					}
				});
			}
			self.embedVerifier.onKeyUpCallback();
		}
	},
	updateTimelineSavedStatus: function(data) {
		var self = this;	
		theTLParantWindow.postMessage({
			type: "save-status",
			saveStatus: data.status
		}, '*');
	}
}

var TLAdminEventCatcher = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.topPos = "";
	self.domCutOffEl = "";
	self.clickFunc = "";
	self.active = false;
    self.controller = data.controller;
	self.disableItemClass ="tl-ah-event-catcher-deactivated";
}

TLAdminEventCatcher.prototype = {
	init: function() {
		var self = this;
		self.topPos = AJKHelpers.getCoordsOfDomEl({ domEl: self.domRoot }).y;
		
		$(self.domRoot).click( function() {
			if (self.clickFunc) {
				self.clickFunc();	
			}
		});
		
		self.deactivatables = $(".tl-ah-event-catcher-deativatable").get();
		return self;
	},
	deactivate: function() {
		var self = this;
		$(self.domRoot).css({ height: 0 });
		theTLMainController.selected3DView.disableHover = false;
		$(self.deactivatables).removeClass(self.disableItemClass);
		self.active = false;
	},
	activate: function(data) {
		var self = this;
		theTLMainController.selected3DView.disableHover = true;
		var cutOffPos = AJKHelpers.getCoordsOfDomEl({ domEl: self.domCutOffEl }).y;
		$(self.domRoot).css({ height: cutOffPos - self.topPos });
		$(self.deactivatables).addClass(self.disableItemClass);
		self.active = true;
	},
	setupAction: function(data) {
		var self = this;
		self.domCutOffEl = data.domCutOffEl;
		self.clickFunc = data.clickFunc;
	},
	fakeClick: function() {
		var self = this;
		$(self.domRoot).click();	
	}
}

var TLTimelineAdvancedSettingsController = function(data) {
	var self = this;
	self.domRoot = "";
	self.controller = data.controller;
	self.mainController = self.controller.mainController;
	self.timeline = self.mainController.timeline;
	self.verifier = "";
	self.lightbox = "";
	self.contentScroller = "";
	self.dateFieldFormatters = [];
}

TLTimelineAdvancedSettingsController.prototype = {
	init: function() {
		var self = this;
		
		/*setTimeout(function() {
			$("#tl-ah-timeline-advanced-settings").click();
		},100);*/

		// We should move a lot of this into a new class 
		$("#tl-ah-timeline-advanced-settings").click( function() {
			if (!self.lightbox) {
				
				self.domRoot = $("#tl-ah-advanced-settings-form-content .ajk-verifier").get()[0];
				// Initialise content with AJKVerifier stuff
				// May need to implement a cancel close function
				self.lightbox = new TLAdminLightbox({
					domClass: "tl-ah-timeline-advanced-settings tl-ah-advanced-settings",
					title: TLConfigText["advancedSettings_title"],
					intro: TLConfigText["advancedSettings_intro"],
					domContent: self.domRoot
				}).init();
				
				self.setupVerification();

				$(self.domRoot).find(".tl-ah-field-date-formatter").each( function() {
					var fieldController = new TLDateFormatterField({ 
						domRoot: this,
						verifier: self.verifier
					 }).init()
					self.dateFieldFormatters.push(fieldController);
				});
				
				$(self.domRoot).find(".ajk-verifier-revert").click( function() {
					$.each( self.dateFieldFormatters, function() {
						this.updateFromFieldValue();
					});
				});

				self.contentScroller  = new AJKContentScrollerController({
					domRootEl: $(self.domRoot).find(".ajk-cs-carousel").get()[0],
					maxHeight: 300
				}).init();
				
				var domHelpDisplayer = $(self.domRoot).find(".tl-asp-help-text").get()[0];
				$(self.domRoot).find(".tl-ahh-help-item").each( function() {
					var thisDomHelp =  $(this).find(".tl-ahh-data-content").get()[0];
					$(thisDomHelp).remove().removeClass("tl-ahh-data-content").removeClass("tl-ahh-data").find("h3").css({display: "none"});
					if (thisDomHelp) {
						if ($.browser.isIOS) {
							$(this).mousedown( function() {
								$(domHelpDisplayer).empty().append(thisDomHelp);
							});
						}
						else {
							$(this).mouseenter( function() {
								$(domHelpDisplayer).empty().append(thisDomHelp);
							}).mouseleave( function() {
								$(thisDomHelp).remove();
							})
						}
					}					
				});


			}
			self.setFieldValues(); // We want to do this everytime we open the panel to ensure that we have the latest data
			self.updatePrivacyPasswordField({ fieldValue: self.timeline.public });
			self.lightbox.openPanel();
			self.contentScroller.enable();
			return false;
		});

		return self;
	},
	setupVerification: function() {
		var self = this;
		self.verifier = new AJKVerifier({
			domRootEl: self.domRoot,
			cancelFunc: function() {
			},
			revertFunc: function() {
				self.verifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
				var vars = data.fieldData;
				vars["timelineId"] = self.controller.timeline.id;
								
				self.verifier.saveFieldValues();
				self.verifier.disableSaveAndRevert();
				
				var refreshNeeded = false;
				
				if (vars.altFlickrImageUrl != self.timeline.altFlickrImageUrl) {
					self.timeline.altFlickrImageUrl = vars.altFlickrImageUrl;
					refreshNeeded = true;
				}
				
				if (vars.dontDisplayIntroPanel != self.timeline.dontDisplayIntroPanel) {
					self.timeline.dontDisplayIntroPanel = vars.dontDisplayIntroPanel;
				}
				
				if (vars.urlHashing != self.timeline.urlHashing) {
					self.timeline.urlHashing= vars.urlHashing;
				}
				
				if (vars.storyDateStatus != self.controller.timeline.storyDateStatus) {
					self.controller.timeline.storyDateStatus = vars.storyDateStatus;
					$.each(self.controller.timeline.markers, function() {
						this.updateDateStatus();	
					});
					self.controller.updateContentPanel({ story: self.mainController.aboutTimelineStory });
				}
				
				if (vars.durHeadlineColour != self.controller.timeline.durHeadlineColour) {
					self.controller.timeline.durHeadlineColour = vars.durHeadlineColour;
					self.mainController.initDurationTextColourStyle();
				}
				
				if (vars.introImageCredit != self.controller.timeline.introImageCredit) {
                    self.controller.timeline.introImageCredit = vars.introImageCredit;
					self.controller.updateTimelineFormVerification.setFieldValues({
						fieldValues: {
							"introImageCredit": vars.introImageCredit,
							forceChangeEvent: true
						}	
					});
					self.controller.updateTimelineFormVerification.savedFieldValues["introImageCredit"] = vars.introImageCredit;
					self.mainController.aboutTimelineStory.images[0].caption = vars.introImageCredit;
					self.controller.updateContentPanel({ story: self.mainController.aboutTimelineStory });
				}
				
				if (vars.language != self.controller.timeline.language) {
					self.mainController.setLanguage({ language: 	vars.language });
					self.mainController.updateViewsWithNewDateRangeAndZoom( { zoom: self.timeline.zoom } );
					self.mainController.flushSize();
					$.each(self.timeline.markers, function() {
						this.updateDisplayDates();
						$(this.domRoot).find(".tl-sb-more-button").text(TLConfigText['marker_moreButton_text']);
					});
					setTimeout( function() {
						self.controller.updateContentPanel({ story: self.mainController.contentPanelController.selectedStory });
						if (self.mainController.userControlsController) {
							self.mainController.userControlsController.langDidChange();
						}
					},10);
				}
				
				if (vars.headerBackgroundColour != self.controller.timeline.headerBackgroundColour || vars.headerTextColour != self.controller.timeline.headerTextColour) {
					self.controller.timeline.headerBackgroundColour = vars.headerBackgroundColour;
					self.controller.timeline.headerTextColour = vars.headerTextColour;
					self.mainController.customiseHeader();
				}

				if (vars.sliderBackgroundColour != self.controller.timeline.sliderBackgroundColour || vars.sliderTextColour != self.controller.timeline.sliderTextColour  || vars.sliderDetailsColour != self.controller.timeline.sliderDetailsColour  || vars.sliderDraggerColour != self.controller.timeline.sliderDraggerColour) {
					self.controller.timeline.sliderBackgroundColour = vars.sliderBackgroundColour;
					self.controller.timeline.sliderTextColour = vars.sliderTextColour;
					self.controller.timeline.sliderDetailsColour = vars.sliderDetailsColour;
					self.controller.timeline.sliderDraggerColour = vars.sliderDraggerColour;
					self.mainController.updateSlider();
				}
				
				if (vars.htmlFormatting != self.controller.timeline.htmlFormatting) {
					self.controller.timeline.htmlFormatting = parseInt(vars.htmlFormatting);
				}
				
				if (vars.expander != self.controller.timeline.expander) {
					self.controller.timeline.expander = vars.expander;
				}
				
				if (vars.displayStripes != self.controller.timeline.displayStripes) {
					self.controller.timeline.displayStripes = vars.displayStripes;
					if (vars.displayStripes == 1) {
						$(self.mainController.domMainHolder).removeClass(self.mainController.hideStripesClass);
					}
					else {
						$(self.mainController.domMainHolder).addClass(self.mainController.hideStripesClass);
					}
				}
				
				if (vars.openReadMoreLinks != self.timeline.openReadMoreLinks) {
					self.timeline.openReadMoreLinks = vars.openReadMoreLinks;
					self.controller.updateContentPanel({ story: self.mainController.contentPanelController.selectedStory });
				}
								
				if (vars.showControls != self.timeline.showControls) {
					self.timeline.showControls = vars.showControls;
					if (vars.showControls == 1) {
						if (!self.mainController.userControlsController) {
							self.mainController.initTimelineControls();
						}
						self.mainController.userControlsController.showButton();
						if (!self.userControlsExtended) {
							self.userControlsExtended = new TLUserControlsExtender({
								userControlsController: self.mainController.userControlsController,
								controller: self
							}).init();	
						}	
					}
					else {
						self.mainController.userControlsController.hideButton();	
					}

				}
				
				
				if (self.controller.timeline.public != vars.public) {
					self.controller.timeline.public = vars.public
					self.updatePrivacyPasswordField({ fieldValue: self.timeline.public });
				}

				if (vars.backgroundImageCredit != self.controller.timeline.backgroundImageCredit) {
                    self.controller.timeline.backgroundImageCredit = vars.backgroundImageCredit;
					self.controller.updateTimelineFormVerification.setFieldValues({
						fieldValues: {
							"backgroundImageCredit": vars.backgroundImageCredit,
							forceChangeEvent: true
						}	
					});
					self.controller.updateTimelineFormVerification.savedFieldValues["backgroundImageCredit"] = vars.backgroundImageCredit;
					$(self.mainController.domMainPhotoCredit).html(vars.backgroundImageCredit);
				}
			
				if (vars.storyDateFormat != self.controller.timeline.storyDateFormat) {
					self.controller.timeline.storyDateFormat = vars.storyDateFormat;
					$.each(self.controller.timeline.markers, function() {
						this.updateDisplayDates();						
					});
				}
				
				 if (vars.topDateFormat != self.controller.timeline.topDateFormat) {
					self.controller.timeline.topDateFormat = vars.topDateFormat;
					self.mainController.selectedView.updateDisplayDate({ date: theTLSettings.currentDate });
				}

				 if (vars.sliderDateFormat != self.controller.timeline.sliderDateFormat) {
					self.controller.timeline.sliderDateFormat = vars.sliderDateFormat;
					self.controller.refreshTimelineView();
				 }
			 
				 if (vars.lightboxStyle != self.controller.timeline.lightboxStyle) {
					self.controller.timeline.lightboxStyle = vars.lightboxStyle;
					$(self.mainController.domContentHolder).removeClass("tl-lightbox-2");
					$("body").removeClass("tl-lightbox-disabled");
					self.mainController.initLightboxStyles();
					self.controller.updateContentPanel({ story: self.mainController.contentPanelController.selectedStory });
				 }
			 
				 if (vars.fontBase != self.timeline.fontBase || vars.fontHead != self.timeline.fontHead || vars.fontBody != self.timeline.fontBody) {
					self.timeline.fontBase = vars.fontBase;
					self.timeline.fontBody = vars.fontBody;
					self.timeline.fontHead = vars.fontHead;
					self.mainController.initFontStyles();
					self.mainController.selected3DView.clearStories3DText();
				 }
				 
				 
				vars.bgScale = parseInt(100 * vars.bgScale,10); // Store 2 dp float as  int
				vars.bgScale = (!vars.bgScale) ? 100 : (vars.bgScale < 10) ? 10 : (vars.bgScale > 1000) ? 1000 : vars.bgScale;

				if (vars.bgScale/100 != self.timeline.bgScale) {
					self.timeline.bgScale = vars.bgScale/100;
					self.mainController.flushSize();
				} 
				
				if (vars.bgStyle != self.timeline.bgStyle) {
					self.timeline.bgStyle = vars.bgStyle;
					self.mainController.flushSize();
				}
				
				self.mainController.selected3DView.redisplay();
				self.controller.updateTimelineSavedStatus({ status: "save-needed" });
				
			}
		}).init();

		self.verifier.onChangeCallback = function(data) {
			if (data.fieldName == "public") {
				self.updatePrivacyPasswordField({ fieldValue: data.fieldValue });
			}
		}

		self.verifier.hideCancelButton();
		self.verifier.showRevertButton();
		self.verifier.disableSaveAndRevert();
		self.setFieldValues();
		
	},
	updatePrivacyPasswordField: function(data) {
		var self = this;
		var fieldValue = data.fieldValue;
		if (fieldValue == "pwd") {
			$("#tl-field-privacy-password").css({ display: "block" });	
		}
		else {
			$("#tl-field-privacy-password").css({ display: "none" });	
		}
	},
	setFieldValues: function() {
		var self = this;	
		self.verifier.setFieldValues({
			fieldValues: {
				introImageCredit: self.timeline.introImageCredit,
				backgroundImageCredit: self.timeline.backgroundImageCredit,
				dontDisplayIntroPanel: self.timeline.dontDisplayIntroPanel,
				openReadMoreLinks: self.timeline.openReadMoreLinks,
				storyDateStatus: self.timeline.storyDateStatus,
				public: self.timeline.public,
				privacyPassword: self.timeline.privacyPassword,
				showTitleBlock: self.timeline.showTitleBlock,
				storyDateFormat: self.timeline.storyDateFormat,
				topDateFormat: self.timeline.topDateFormat,
				sliderDateFormat: self.timeline.sliderDateFormat,
				language: self.timeline.language,
				displayStripes: self.timeline.displayStripes,
				htmlFormatting: self.timeline.htmlFormatting,
				sliderBackgroundColour: self.timeline.sliderBackgroundColour,
				sliderTextColour: self.timeline.sliderTextColour,
				sliderDetailsColour: self.timeline.sliderDetailsColour,
				sliderDraggerColour: self.timeline.sliderDraggerColour,
				headerBackgroundColour: self.timeline.headerBackgroundColour,
				headerTextColour: self.timeline.headerTextColour,
				durHeadlineColour: self.timeline.durHeadlineColour,
				cssFile: self.timeline.cssFile,
				altFlickrImageUrl: self.timeline.altFlickrImageUrl,
				fontBase: self.timeline.fontBase,
				fontHead: self.timeline.fontHead,
				fontBody: self.timeline.fontBody,
				lightboxStyle: self.timeline.lightboxStyle,
				showControls: self.timeline.showControls,
				lazyLoading: self.timeline.lazyLoading,
				expander: self.timeline.expander,
				bgScale: self.timeline.bgScale,
				bgStyle: self.timeline.bgStyle
			}
		});

		self.verifier.saveFieldValues();
		
		$.each( self.dateFieldFormatters, function() {
			this.updateFromFieldValue();
		});
	}
}

var TLDateFormatterField = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.domInput = $(data.domRoot).find("input").get()[0];
	self.domSelect = "";
	self.verifier = data.verifier;
	self.fieldName = $(self.domInput).attr("name");
}

TLDateFormatterField.prototype = {
	init: function() {
		var self = this;
		self.domSelect = self.createSelect();
		$(self.domRoot).find(".tl-ah-input").before(self.domSelect);
		
		$(self.domInput).change( function() {
			$(self.domSelect).val($(this).val());
		});
		 
		$(self.domInput).keyup( function() {
			$(self.domSelect).val($(this).val());
		});
		 
		$(self.domSelect).change( function() {
			if (self.verifier) {
				var data = {};
				data[self.fieldName] = $(this).val();
				self.verifier.setFieldValues( {
					fieldValues: data,
					forceChangeEvent: true
				});
			}
			else {
				$(self.domInput).val($(this).val());
			}
		});
		 
		return self;	
	},
	updateFromFieldValue: function() {
		var self = this;
		$(self.domSelect).val($(self.domInput).val());
	},
	createSelect: function() {
		var self = this;	
		var insertHTML = '<select>';
		$.each( TLConfigText["dateFormatting_items"], function() {
			insertHTML += '<option value="'+this[0]+'">'+this[1]+'</option>';
		});
		insertHTML += '</select>';
		return $(insertHTML).get()[0];
	}
}

var TLAdminFeedController = function(data) {
	var self = this;
	self.controller = data.controller;
	self.timeline = self.controller.timeline;
	self.mainController = self.controller.mainController;
	self.eventCatcherController = self.controller.eventCatcherController;
	self.listController = "";
	self.domRoot = $("#tab-my-selected-timeline-feeds").get()[0];
	self.selectedFeed = "";
	self.domSelectedFeedHeadline = $(self.domRoot).find("#tl-ah-selected-feed-title").get()[0];
	self.verifier = "";
	self.domForm = $(self.domRoot).find("#tl-ah-timeline-feeds-form").get()[0];
	self.domSourceSpecificFields = $(self.domRoot).find(".tl-feeds-source-specific-fields").get();
	self.domFilterSpecificFields = $(self.domRoot).find(".tl-feeds-filter-specific-fields").get();
	self.flickrApiKey = theTLSettings.flickrApiKey;
}

TLAdminFeedController.prototype = {
	init: function() {
		var self = this;	
		self.setupList();
		self.setupVerifier();

		$(self.domRoot).find("#tl-ah-story-add-feed-button a").click( function() {
			if (self.timeline.feeds.length < 5) {
				self.createNewFeed();
			}
			else {
				self.controller.adminAlertController.displayMessage({
					headline: TLConfigText["feedsPanel_feedLimit_title"],
					body: '<p>'+TLConfigText["feedsPanel_feedLimit_message"]+'</p>'
				});
			}
			return false;
		});
		
		$(self.domForm).css({ display: "none" });
		
		$("#tl-feeds-tab-menu-item").click( function() {
			if (self.selectedFeed) {
				self.selectFeed({ feed: self.selectedFeed, forceUpdate: true });
			}
			else {
				self.feedPanelOpened();
			}
			self.controller.helpController.setBaseHelpByName({ baseName: "help-feed" });
		});

	},
	updateSourceSpecificFields: function(data) {
		var self = this;
		var source = data.source;
		$(self.domSourceSpecificFields).css({display: "none" });
		$("#tl-feeds-"+source+"-fields").css({ display: "block" });
		
		if (source == "json") {
			$("#tl-ah-feeds-num-items-field").css({ display: "none" });
		}
		else {
			$("#tl-ah-feeds-num-items-field").css({ display: "block" });
		}
		
		var filterValue = self.verifier.getFieldValueFromName({ fieldName:  "feed_"+source+"_filter" });
		self.updateFilterSpecificFields({filter: filterValue });	

	},
	updateFilterSpecificFields: function(data) {
		var self = this;
		var filter = data.filter;
		$(self.domFilterSpecificFields).css({display: "none" });
		$("#tl-feeds-"+filter+"-fields").css({ display: "block" });
	},
	setupVerifier: function() {
		var self = this;
		
		self.verifier = new AJKVerifier({
			domRootEl: self.domForm,
			cancelFunc: function() {
				self.deleteFeed({feed: self.selectedFeed});
			},
			revertFunc: function() {
				self.verifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {

				self.controller.displayStandardSavingAlertMessage();
				
				var oldParam1 = self.selectedFeed.param1;
				var oldFilter = self.selectedFeed.filter;
				var oldSource = self.selectedFeed.source;
				var oldNumItems = self.selectedFeed.numItems; 
				var feedNeedsUpdating = false;
				
				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["id"] = self.selectedFeed.id;

				self.selectedFeed.name = vars["feedName"];
				self.selectedFeed.source = vars["feedSource"];
				self.selectedFeed.filter = vars["feed_"+vars["feedSource"]+"_filter"];
				
				switch (vars["feedSource"]) {
					case "flickr":
						if (self.selectedFeed.filter == "flickr-username") {
							self.selectedFeed.param1 = vars["feedFlickrUsername"];
						}
						else if (self.selectedFeed.filter == "flickr-search") {
							self.selectedFeed.param1 = vars["feedFlickrSearch"];
						}
						else {
							self.selectedFeed.param1 = "";
						}
						self.selectedFeed.param2 = "";
					break;
					case "twitter":
						if (self.selectedFeed.filter == "twitter-username") {
							self.selectedFeed.param1 = vars["feedTwitterUsername"];
						}
						else if (self.selectedFeed.filter == "twitter-search") {
							self.selectedFeed.param1 = vars["feedTwitterSearch"];
						}
						else {
							self.selectedFeed.param1 = "";
						}
						self.selectedFeed.param2 = "";
					break;
					case "youtube":
						if (self.selectedFeed.filter == "youtube-username") {
							self.selectedFeed.param1 = vars["feedYouTubeUsername"];
						}
						else if (self.selectedFeed.filter == "youtube-search") {
							self.selectedFeed.param1 = vars["feedYouTubeSearch"];
						}
						else {
							self.selectedFeed.param1 = "";
						}
						self.selectedFeed.param2 = "";
					break;
					case "rss":
					
					
					break;	
				}

				vars["param1"] = self.selectedFeed.param1;
				vars["param2"] = self.selectedFeed.param2;
				vars["feedId"] = self.selectedFeed.id;
				vars["feedFilter"] = 	self.selectedFeed.filter;
				
				self.selectedFeed.path = self.generateFeedPath({ feed: self.selectedFeed });
				vars["path"] = self.selectedFeed.path;
				
				self.selectedFeed.numItems = vars["numItems"]; 

				var relatedFeed = self.selectedFeed;
				
				var newItem = (self.selectedFeed.id == "awaitingId") ? true : false; 
								
				self.verifier.saveFieldValues();
				self.verifier.hideCancelButton();
				self.verifier.showRevertButton();
				self.verifier.disableSaveAndRevert();
				
				self.eventCatcherController.deactivate();

				var existingFeedNeedsToBeReloaded = false;
				if (!newItem && (oldParam1 != self.selectedFeed.param1 || oldFilter != self.selectedFeed.filter || oldSource != self.selectedFeed.source || oldNumItems != self.selectedFeed.numItems)) {
					existingFeedNeedsToBeReloaded = true;
				}

				if (newItem) {
					var feedId =  theTLCreateIdCounters.feed++;
					relatedFeed.id = feedId;
					self.mainController.feedController.loadNewFeed({
						feed: relatedFeed,
						callback: function() {
							self.mainController.refreshTimelineAfterFeedChange();
							self.controller.adminAlertController.fadeOut();
						}
					});
					if (self.selectedFeed == relatedFeed) { 
						self.listController.resetWithNewListItems({ listItems: self.timeline.feeds });
						self.listController.showAndSelectListItem({ listItem: relatedFeed, instantly: true });
					}
				}
				else {
					self.listController.resetWithNewListItems({ listItems: self.timeline.feeds });
					if (self.selectedFeed == relatedFeed) { 
						self.listController.showAndSelectListItem({ listItem: relatedFeed, instantly: true });
					}
					if (existingFeedNeedsToBeReloaded) {
						self.mainController.feedController.removeFeed({ feed: relatedFeed });
						self.mainController.feedController.loadNewFeed({
							feed: relatedFeed,
							callback: function() {
								self.mainController.refreshTimelineAfterFeedChange();
								self.controller.adminAlertController.fadeOut();
							}
						});
					}
					else {
						setTimeout(function() {
							self.controller.adminAlertController.fadeOut();
						},1);
					}
				}

				var viewRefreshNeededForCategoryBandView = false;
				if (self.selectedFeed.category.id != vars["feedCategory"]) {
					self.selectedFeed.category = self.timeline.categoriesByKey[self.mainController.categoriesKeyPrefix+vars["feedCategory"]];
					self.selectedFeed.category = (self.selectedFeed.category) ? self.selectedFeed.category : self.mainController.defaultCategory;
					if (self.selectedFeed.markers) {
						$.each( self.selectedFeed.markers, function() {
							this.category = self.selectedFeed.category;
							this.categoryHasChanged();
						});
					}					
					viewRefreshNeededForCategoryBandView = true;
				}

				if (viewRefreshNeededForCategoryBandView && self.timeline.viewType) {
					self.controller.refreshTimelineView();
				}
                self.controller.updateTimelineSavedStatus({ status: "save-needed" });
							
			}
		}).init();
		
	},
	generateFeedPath: function(data) {
		var self = this;
		var feed = data.feed;
		var path = "";
		switch (feed.source) {
			case "flickr":
				path = "";
			break;
		}
		return path;
	},
	createNewFeed: function() {
		var self = this;
		var newFeed = {
			name: TLConfigText["feedsPanel_New_Feed"],
			source: "rss",
			filter: "",
			param1: "",
			param2: "",
			path: "",
			orderIndex: self.timeline.feeds.length,
			id: "awaitingId",
			category: (self.timeline.categories[0]) ? self.timeline.categories[0] : self.mainController.defaultCategory,
			numItems: 10
		}	
		self.listController.addListItemAtIndex({
			listItem: newFeed,
			index: self.timeline.feeds.length
		});
		self.timeline.feeds.push(newFeed);
		self.selectFeed( { feed: newFeed, isNewFeed: true });
	},
	clearFields: function() {
		var self = this;
		self.verifier.setFieldValues({
			fieldValues: {
				feedFlickrSearch: "",
				feedFlickrUsername: "",
				feedYouTubeSearch: "",
				feedYouTubeUsername: "",
				feedTwitterSearch: "",
				feedTwitterUsername: ""
			}
		});

	},
	selectFeed: function(data) {
		var self = this;
		var forceUpdate = data.forceUpdate;
		var feed = data.feed;
		var oldFeed = self.selectedFeed;
		self.selectedFeed = feed;

		setTimeout( function() {
			self.controller.helpController.setBaseHelpByName({ baseName: "help-feed" });
		},1);

		self.feedPanelOpened();
		self.listController.showAndSelectListItem({ listItem: self.selectedFeed, instantly: true });
		
		if (self.selectedFeed != oldFeed || self.updateDisplayedFeed || forceUpdate) { 
			
			self.updateSourceSpecificFields({ source: self.selectedFeed.source });
			self.updateFilterSpecificFields({ filter: self.selectedFeed.filter });
			
			$(self.domForm).css({ display: "block" });

			$(self.domSelectedFeedHeadline).text(feed.name);
			
			// We need to select any media items and focus on the basic info tab for the story

			self.verifier.onChangeCallback = "";
			self.verifier.onKeyUpCallback = "";

			self.clearFields();
			
			var fieldValues = {
				feedName: feed.name,
				feedSource: feed.source,
				feedCategory: feed.category.id,
				numItems: feed.numItems
			}

			fieldValues["feed_"+feed.source+"_filter"] = feed.filter;
			
			if (feed.filter == "flickr-username") {
				fieldValues["feedFlickrUsername"] = feed.param1;
			}
			else if (feed.filter == "flickr-search") {
				fieldValues["feedFlickrSearch"] = feed.param1;
			}
			else if (feed.filter == "youtube-username") {
				fieldValues["feedYouTubeUsername"] = feed.param1;
			}
			else if (feed.filter == "youtube-search") {
				fieldValues["feedYouTubeSearch"] = feed.param1;
			}
			else if (feed.filter == "twitter-username") {
				fieldValues["feedTwitterUsername"] = feed.param1;
			}
			else if (feed.filter == "twitter-search") {
				fieldValues["feedTwitterSearch"] = feed.param1;
			}

			self.verifier.setFieldValues({
				fieldValues: fieldValues
			});
			
			if (self.selectedFeed.id && self.selectedFeed.id != "awaitingId") {
				self.verifier.hideCancelButton();
				self.verifier.showRevertButton();
				self.verifier.disableSaveAndRevert();
				self.verifier.saveFieldValues();
			}
			else {
				// feed has no ID so has not been saved yet so we display the cancel rather than the revert button
				self.verifier.hideRevertButton();
				self.verifier.showCancelButton();
				self.verifier.enableSaveAndRevert();
				self.eventCatcherController.activate(); // Catch click away events because new feed and not saved
			}
						
			var updateFeedFormEventCatcher = function() {
				if (self.verifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}
			// We need functions for observing every change - ie title
			// And for the onChange event - ie images 
			self.verifier.onChangeCallback = function(data) {
				if (data.fieldName == "feedSource") {
					self.updateSourceSpecificFields({ source: data.fieldValue });
				}
				else if (data.fieldName.indexOf("filter") != -1) {
					self.updateFilterSpecificFields({ filter: data.fieldValue });
				}
				else if (data.fieldName == "feedName") {
					self.selectedFeed.name = data.fieldValue;
					$(self.domSelectedFeedHeadline).text(data.fieldValue);
					$("#admin-feed-list-item-title-"+self.selectedFeed.id).text(data.fieldValue);
				}

				updateFeedFormEventCatcher();
			}
			
			self.verifier.onKeyUpCallback = function(data) {
				if (data.fieldName == "feedName") {
					self.selectedFeed.name = data.fieldValue;
					$(self.domSelectedFeedHeadline).text(data.fieldValue);
					$("#admin-feed-list-item-title-"+self.selectedFeed.id).text(data.fieldValue);
				}
				updateFeedFormEventCatcher();
			}
			// Deselect old story if necessary
		}

	},
	feedPanelOpened: function() {
		var self = this;
		self.listController.refresh();
		self.eventCatcherController.setupAction({
			domCutOffEl: self.domForm,
			clickFunc: function() {
				if (self.selectedFeed.id != "awaitingId") { // Existing feed
					self.controller.adminAlertController.displayMessage({
						headline: TLConfigText["feedsPanel_unsavedChanges1_headline"],
						body: '<p>'+TLConfigText["feedsPanel_unsavedChanges1_message1"]+' “'+self.selectedFeed.name+'”. '+TLConfigText["feedsPanel_unsavedChanges1_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								self.verifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
							action: function() {
								self.verifier.fireButton({ buttonType: "revert" });
							}	
						}]	
					});
				}
				else { // New feed
					self.controller.adminAlertController.displayMessage({
						headline: TLConfigText["feedsPanel_unsavedChanges2_headline"],
						body: '<p>'+TLConfigText["feedsPanel_unsavedChanges2_message1"]+' “'+self.selectedFeed.name+'”. '+TLConfigText["feedsPanel_unsavedChanges2_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								self.verifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Delete']+'</a>',
							action: function() {
								// Cancel the new story
								self.verifier.fireButton({ buttonType: "cancel" });
							}	
						}]	
					});
				}
				
			}
		});

	},
	deleteFeed: function(data) {
		var self = this;

		var feed = data.feed;
		self.listController.removeListItem({
			listItem: feed
		});

		var vars = {};
		vars["feedId"] = feed.id;
		vars["timelineId"] = self.timeline.id;
        
		self.timeline.feeds = AJKHelpers.removeItemFromArray({anArray: self.timeline.feeds, item: feed });

        self.mainController.feedController.removeFeed({ feed: feed });
        self.mainController.refreshTimelineAfterFeedChange();
		
		if (self.selectedFeed == feed) {
			self.selectedFeed = "";
			$(self.domForm).css({ display: "none" });
		}
		
		self.eventCatcherController.deactivate();

		self.controller.updateTimelineSavedStatus({ status: "save-needed" });
	},
	setupList: function() {
		var self = this;	
		self.listController = new AJKScrollableListController({
			stagePadding: 0,
			domRoot: $(self.domRoot).find(".ajk-cs-carousel").get()[0],
			domStage: $(self.domRoot).find(".ajk-cs-carousel-stage").get()[0],
			listItems: self.timeline.feeds,
			createDomListItemFunc: function(data) {
				var aFeed = data.listItem;				
				var insertHTML = '<div feedId="'+aFeed.id+'" class="tl-ah-list-item">';
				insertHTML+='<div class="tl-ah-col-1">';
				insertHTML+='<p id="admin-feed-list-item-title-'+aFeed.id+'">'+aFeed.name+'</p>';
				insertHTML+='</div>';
				insertHTML+='<div class="tl-ah-col-2">';
				insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
				insertHTML+='</div>';
				insertHTML+='</div>';					
				return $(insertHTML).get()[0];
			},
			listItemSelectClass: "tl-ah-list-item-selected",
			itemWasClickedFunc: function(data) {
				var feed = data.listItem;
				var clickedElClass = data.clickedElClass;
				if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
					// delete the clickedEl;
					self.controller.adminAlertController.displayMessage({
						headline: TLConfigText["feedsPanel_deleteFeed_title"],
						body: '<p>'+TLConfigText["feedsPanel_deleteFeed_message"]+' “'+feed.name+'”?</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No'] +'</a>',
							action: function() {}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes'] +'</a>',
							action: function() {
								// Delete the story
								self.deleteFeed({ feed: feed });
							}	
						}]	
					});
					
				}
				else {
					self.selectFeed( { feed: feed });
				}
			},
			getKeyForListItem: function(data) {
				var feed = data.listItem;
				return feed.id;
			},
			getPositionForListItem: function(data) {
				var feed = data.listItem;	
				return feed.orderIndex;
			}
		}).init();		
	}
}


var TLImagePositioningController = function(data) {
	var self = this;
	self.imageSelector = data.imageSelector; // object we communicate with to decide what image to show
	self.lightbox = "";
	self.domLaunchButton = $("#tl-ah-image-position-panel-launch").get()[0];
	self.domPanelContent = $("#tl-ah-image-positioning-panel").get()[0];
	self.domImageContainers = $(self.domPanelContent).find(".tl-ahip-img-holder").get();
	self.imageContainers = "";
	self.domMainContainer = $(self.domPanelContent).find(".tl-ahip-main-img-holder").get()[0];
	self.domFakeDragger = $(self.domPanelContent).find(".tl-ahip-fake-dragger").get()[0];
	self.domHorizSelect = $(self.domPanelContent).find(".tl-ahip-input-horiz-align select").get()[0]; 
	self.domVerticalSelect = $(self.domPanelContent).find(".tl-ahip-input-vertical-align select").get()[0]; 
	self.mainContainer = "";
	self.draggable = "";
	self.imageOffset = {
		x: 0,
		y: 0		
	}
	self.portraitClass = "tl-ah-ipp-portrait-image";
}

TLImagePositioningController.prototype = {
	init: function() {
		var self = this;
		$(self.domLaunchButton).click( function() {
			self.initImageOffset();
			if (self.imageSelector.domDataUriField) {
				self.selectedImage = $.data(self.imageSelector.domDataUriField,"value");
			}
                                      
			if (!self.selectedImage) {
				self.selectedImage = AJKHelpers.getTimelineImageUrl({ src: $(self.imageSelector.domContentField).val() });
			}
			if (!self.selectedImage || self.selectedImage == TLConfigText['marker_media_Enter_meda_source_here']) {
				AJKHelpers.jiggleDomEl({
					domEl: this,
					displacementFactor: 5
				});
				return false;	
			}
			if (!self.lightbox) {
				self.initPanel();
			}
			self.launch();
			return false;
		});
		//$(self.domLaunchButton).click();
		AJKHelpers.cancelSelectionOnDomEl({ domEl: self.domFakeDragger });
		return self;	
	},
	initImageOffset: function() {
		var self = this;
		var fieldVal = $(self.imageSelector.domThumbPosField).val();
		if (fieldVal) {
			var splitVal = fieldVal.split(",");
			self.imageOffset.x = (splitVal[0]) ? parseFloat(splitVal[0]) : 0;
			self.imageOffset.y = (splitVal[1]) ? parseFloat(splitVal[1]) : 0;
		}
		else {
			self.imageOffset.x = 0;
			self.imageOffset.y = 0;
		}

	},
	initPanel: function() {
		var self = this;
		self.lightbox = new TLAdminLightbox({
			domClass: "tl-ah-fis-panel-wide",
			title: TLConfigText["positioningPanel_title"],
			intro: TLConfigText["positioningPanel_intro"],
			domContent: self.domPanelContent,
			closeCallback: function() {
				//self.imageSelector.feedSelector.openPanel();
				$(self.imageContainers).find("img").remove();
				self.populatePositionField();
				self.deactivateAlignmentSelects();
			}
		}).init();	
	},
	populatePositionField: function() {
		var self = this;
		var fieldText = self.imageOffset.x+","+self.imageOffset.y;
		$(self.imageSelector.domThumbPosField).val(fieldText).blur();
	},
	launch: function() {
		var self = this;
		//self.imageSelector.feedSelector.closePanel();
		self.lightbox.openPanel();
		new AJKImageLoader({
			imageUrl: self.selectedImage,
			loadCallback: function() {
				var imageSize = AJKHelpers.getImageSize({ imageUrl: self.selectedImage });
				if (imageSize.height/imageSize.width > 1.2) {
					$(self.domPanelContent).addClass(self.portraitClass);
				}
				else {
					$(self.domPanelContent).removeClass(self.portraitClass);
				}
				self.initialiseContainers();
				self.initialiseImages();
				setTimeout( function() {
					self.updateImagePositions();
					self.initialiseDrag();
					self.initialiseAlignmentSelects();
					self.updateAlignmentFields();
				},1);
			}
		}).init();
	},
	deactivateAlignmentSelects: function() {
		var self = this;
		$(self.domHorizSelect).unbind("change");
		$(self.domVerticalSelect).unbind("change");
	},
	initialiseAlignmentSelects: function() {
		var self = this;
		$(self.domHorizSelect).change( function() {
			var thisVal = $(this).val();
			if (thisVal != "custom") {
				self.imageOffset.x = parseInt(thisVal);
			}
			self.updateImagePositions();
		});
		$(self.domVerticalSelect).change( function() {
			var thisVal = $(this).val();
			if (thisVal != "custom") {
				self.imageOffset.y = parseInt(thisVal);
			}
			self.updateImagePositions();
		});
	},
	initialiseContainers: function() {
		var self = this;
		self.imageContainers  = [];
		$(self.domImageContainers).each( function() {
			var thisObj = {
				domEl: this,
				domImage: "",
				boxSize: {
					width: $(this).width(),
					height: $(this).height()	
				},
				scaleImageSize: ""
			}
			self.imageContainers.push(thisObj);
			if (this == self.domMainContainer) {
				self.mainContainer = thisObj;
			}
		});
	},
	initialiseDrag: function() {
		var self = this;
		self.draggable = new AJKDraggable({
			domDragEl: $(self.domMainContainer).find("img").get()[0],
			limitFunc: function() {
				var limit = {
					minX: -(self.mainContainer.scaledImageSize.width - self.mainContainer.boxSize.width),
					maxX: 0,
					minY: -(self.mainContainer.scaledImageSize.height - self.mainContainer.boxSize.height),
					maxY: 0
				}
				return limit;			
			},
			mouseMoveFunc: function(data) {
				var centerXOffset = (self.mainContainer.scaledImageSize.width - self.mainContainer.boxSize.width)/2;
				self.imageOffset.x = (Math.abs(data.dragElPos.x) - centerXOffset)/centerXOffset;
				self.imageOffset.x = (self.imageOffset.x) ? self.imageOffset.x : 0;
				self.imageOffset.x = AJKHelpers.convertNumToXDecimalPlaces({ num: self.imageOffset.x, x: 4 });
				var centerYOffset = (self.mainContainer.scaledImageSize.height - self.mainContainer.boxSize.height)/2;
				self.imageOffset.y = (Math.abs(data.dragElPos.y) - centerYOffset)/centerYOffset;
				self.imageOffset.y = (self.imageOffset.y) ? self.imageOffset.y : 0;
				self.imageOffset.y = AJKHelpers.convertNumToXDecimalPlaces({ num: self.imageOffset.y, x: 4 });
				self.updateImagePositions();
				self.updateAlignmentFields();
			},
			dragDidStartFunc: function() {
			},
			dragDidEndFunc: function() {
				self.updateAlignmentFields();
			}
		});
		
		// Use fake draggable el above image to initiate drag rather than using draggable standard init. Solves issues with image and dragging
		$(self.domFakeDragger).mousedown( function(e) {
			self.draggable.initiateDrag({ event: e });	
		});
	},
	updateAlignmentFields: function() {
		var self = this;
		if (parseInt(self.imageOffset.x) == self.imageOffset.x) {
			$(self.domHorizSelect).val(self.imageOffset.x);
		}
		else {
			$(self.domHorizSelect).val("custom");
		}
		if (parseInt(self.imageOffset.y) == self.imageOffset.y) {
			$(self.domVerticalSelect).val(self.imageOffset.y);
		}
		else {
			$(self.domVerticalSelect).val("custom");
		}
	},
	initialiseImages: function() {
		var self = this;
		
		$(self.imageContainers).each( function() {
			var thisObj = this;
			var domImage = $('<img src="'+self.selectedImage+'" alt="" />').get()[0];
			$(this.domEl).empty().append(domImage);
			this.domImage = domImage;
			setTimeout( function() {
				thisObj.imageSize = {
					width: $(domImage).width(),				
					height: $(domImage).height()		
				}
			},0);
		});
	},
	updateImagePositions: function() {
		var self = this;
		$(self.imageContainers).each( function() {
			this.scaledImageSize =  AJKHelpers.sizeImageToFitInBoxOfSize({
				domImage: this.domImage,
				boxSize: this.boxSize,
				imageSize: this.imageSize,
				returnScaledImageSize: true,
				imageOffset: self.imageOffset
			});
		});
	}
}

var TLPDFServices = function(data) {
	var self = this;
	self.controller = data.controller;
	self.timeline = self.controller.timeline;
	self.domLaunchButton = $("#tl-ah-pdf-timeline").get()[0];
	self.domContent = $("#tl-ah-pdf-panel").get()[0];
	self.imageModeUrl = "http://"+TLTimelineData.host+"/timeline/imagemode/"+self.timeline.id+"/"+self.timeline.urlFriendlyTitle+"/";
}

TLPDFServices.prototype = {
	init: function() {
		var self = this;
		if ($.browser.isMac) {
			$(self.domContent).addClass("tl-ah-show-mac-content");	
		}
		var lightbox = "";
		$(self.domLaunchButton).click( function() {
			// Need to show the lightbox here
			if (!lightbox) {
				lightbox = new TLAdminLightbox({
					domClass: "tl-ah-embed-lightbox",
					title: "PDF Generation",
					intro: "<p>To generate a PDF of your timeline, select the 'Print' or 'Print Text' option from the File menu, and then choose the PDF option in the print panel that appears.</p>",
					domContent: self.domContent
				}).init();	
				$(self.domContent).find(".tl-ah-pdf-web-link").text(self.imageModeUrl);
			}
			lightbox.openPanel();
			return false;
		});
		
		//$(self.domLaunchButton).click();
		return self;
	}	
}

var TLCSVServices = function(data) {
	var self = this;
	self.domLaunchButton = $("#tl-ah-csv-timeline").get()[0];
	self.domContent = $("#tl-ah-csv-panel").get()[0];
	self.domTextArea = $("#tl-ah-csv-textarea").get()[0];
}

TLCSVServices.prototype = {
	init: function() {
		var self = this;
		var lightbox = "";
		$(self.domLaunchButton).click( function() {
			// Need to show the lightbox here
			if (!lightbox) {
				$(self.domExportButton).click( function() {
					$(self.domDownloadingMessage).css({ display: "block" });
					$(self.domExportButton).css({ display: "none" });
				});
				lightbox = new TLAdminLightbox({
					domClass: "tl-ah-embed-lightbox",
					title: TLConfigText["csv_panel_title"],
					intro: "<p>Export your timeline data in CSV format</p>",
					domContent: self.domContent
				}).init();	
			}
			$(self.domTextArea).val(self.generateCSVForTimeline());
			
			lightbox.openPanel();
			self.domTextArea.select();
			return false;
		});
		return self;
	},
	generateCSVForTimeline: function() {
		var self = this;
		var stories = theTLMainController.markers;
		var tagsByKey = theTLMainController.timeline.tagsByKey;
		var tagsKeyPrefix = theTLMainController.tagsKeyPrefix;
		
		var csvText = '"Title","Start Date","End Date","Intro","Full Text","Category","dateFormat","External Link","Images","Videos","Audio","Tags"';

		$.each(stories, function() {
			var story = this;
			csvText += "\n";
			csvText += self.escapeCSVString(story.headline)+",";
			
			var startDate = AJKHelpers.formatDate({
				date: Date.parse(story.startDate),
				formatString: "YYYY-MM-DD HH:mm:ss",
				forceFullDate: true,
				language: "base"
			});
			csvText += self.escapeCSVString(startDate)+",";
			
			var endDate = AJKHelpers.formatDate({
				date: Date.parse(story.endDate),
				formatString: "YYYY-MM-DD HH:mm:ss",
				forceFullDate: true,
				language: "base"
			});
			csvText += self.escapeCSVString(endDate)+",";
			
			csvText += self.escapeCSVString(story.introText)+",";
			csvText += self.escapeCSVString(story.fullText)+",";
			var category = (story.category) ? story.category.title : "";
			csvText += self.escapeCSVString(category)+",";
			csvText += self.escapeCSVString(story.dateFormat)+",";
			csvText += self.escapeCSVString(story.externalLink)+",";
			
			var imageStr = "";
			$.each(story.media, function() {
				var media = this;
				if (media.type == "Image") {
					imageStr = (!imageStr) ? media.src : imageStr+"\n"+media.src;
					if (media.caption) {
						imageStr += "["+media.caption+"]";
					}
				}
			});
			csvText += self.escapeCSVString(imageStr)+",";

			var videoStr = "";
			$.each(story.media, function() {
				var media = this;
				if (media.type == "Video") {
					videoStr = (!videoStr) ? media.src : videoStr+"\n"+media.src;
					if (media.caption) {
						videoStr += "["+media.caption+"]";
					}
				}
			});
			csvText += self.escapeCSVString(videoStr)+",";

			var audioStr = "";
			$.each(story.media, function() {
				var media = this;
				if (media.type == "Audio") {
					audioStr = (!audioStr) ? media.src : audioStr+"\n"+media.src;
					if (media.caption) {
						audioStr += "["+media.caption+"]";
					}
				}
			});
			csvText += self.escapeCSVString(audioStr)+",";
						
			var tagIds = (story.tags) ? story.tags.split(",") : [];
			var tagStr = "";
			
			
			$.each(tagIds, function() {
				var tId = this;
				var tag = tagsByKey[tagsKeyPrefix+tId];
				
				if (tag) {
					tagStr = (!tagStr) ? tag.text : tagStr+","+tag.text;
				}
			});
			csvText += self.escapeCSVString(tagStr);

		});
		return csvText;
	},
	escapeCSVString: function(aString) {
		var self = this;
		if (!aString) {
			return '""';	
		}
		return '"'+aString.replace(/"/g,"\"")+'"';
	}
}

var TLStoryEditButton = function(data) {
	var self = this;
	self.selectedStory = "";
	self.domRoot = "";
	self.callback = data.callback;
	self.controller = data.controller;
	self.mainController = self.controller.mainController;
}

TLStoryEditButton.prototype = {
	init: function() {
		var self = this;	
		return self;
	},
	showForStory: function(data) {
		var self = this;
		var story = data.story;
		if (story.uneditable) {
			return;	
		}
		self.selectedStory = story;
		if (!self.domRoot) {
			self.generate();	
		}
		var view3D = self.mainController.selected3DView;
		if (view3D.active) {
			var info3D = self.selectedStory.marker3DScreenInfo; 
			if (info3D.timelinePos.y > view3D.moreInfoCutOff) {
				$(self.dom3DRoot).css({ left: info3D.x, top: info3D.y });
				$(self.mainController.domStageHolder).prepend(self.dom3DRoot);
			}
		}
		else {
			$(story.domRoot).prepend(self.domRoot);
		}
	},
	remove: function() {
		var self = this;
		$(self.domRoot).detach();
		$(self.dom3DRoot).detach();
		self.selectedStory = "";
	},
	generate: function() {
		var self = this;	
		self.domRoot = $('<div class="tl-st-edit-button">Edit story</div>').get()[0];
		self.dom3DRoot = $('<div class="tl-st-edit-button tl-st-edit-button-3d">Edit story</div>').get()[0];
		$([self.domRoot,self.dom3DRoot]).click( function() {
			self.callback({ story: self.selectedStory });
			return false;
		});
		$(self.dom3DRoot).mousemove( function(e) {
			e.stopPropagation();
		});
	}
}

/* Class for extending user controls in admin mode */
var TLUserControlsExtender = function(data) {
	var self = this;
	self.controller = data.controller;
	self.timeline = self.controller.timeline;
	self.userControlsController = data.userControlsController;
}

TLUserControlsExtender.prototype = {
	init: function() {
		var self = this;
		if (!self.timeline.isEditable) {
			return;	
		}
		self.setupWarningPanel();
		return self;
	},
	setupWarningPanel: function() {
		var self = this;
		self.domWarningPanel = $('<div class="tl-uc-controls-warning"><h3>Important Info</h3><p>These controls are aimed at viewers of your timeline. They should not be used to edit your timeline.</p><p>If you need to change your timeline\'s zoom, view type, or spacing mode, you should use the options in the Settings tab in the grey admin panel.</p><a href="#" class="rt-button-3">Continue</a></div>').get()[0];
		$(self.domWarningPanel).find(".rt-button-3").click( function() {
			$(self.domWarningPanel).animate({ opacity: 0 }, 500, function() {
				$(this).remove();	
			});
			return false;	
		});
		
		$(self.userControlsController.domPanel).find(".tl-ucp-content").append(self.domWarningPanel);
	}
}

/* 3d Timeline Settings */
var TLTimeline3DSettings = function(data) {
	var self = this;
	self.slidersInitialised = false;
	self.controller = data.controller;
	self.mainController = self.controller.mainController;
	self.timeline = self.controller.timeline;
	self.timeline3D = self.timeline.timeline3D;
}

TLTimeline3DSettings.prototype = {
	init: function() {
		var self = this;

		$("#tl-ah-timeline-3d-settings").click( function() {
			if (!self.lightbox) {
				
				self.domRoot = $("#tl-ah-3d-settings-form-content .ajk-verifier").get()[0];
				// Initialise content with AJKVerifier stuff
				// May need to implement a cancel close function
				self.lightbox = new TLAdminLightbox({
					domClass: "tl-ah-timeline-3d-settings tl-ah-advanced-settings",
					title: TLConfigText["3DSettings_title"],
					intro: TLConfigText["3DSettings_intro"],
					domContent: self.domRoot,
					closeCallback: function() {
						// only allow to close if saved or reverted
						self.verifier.fireButton({ buttonType: "revert" })

					}
				}).init();	
				
				self.setupVerification();
				
				/*var domHelpDisplayer = $(self.domRoot).find(".tl-asp-help-text").get()[0];
				$(self.domRoot).find(".tl-ahh-help-item").each( function() {
					var thisDomHelp =  $(this).find(".tl-ahh-data-content").get()[0];
					$(thisDomHelp).remove().removeClass("tl-ahh-data-content").removeClass("tl-ahh-data").find("h3").css({display: "none"});
					if (thisDomHelp) {
						$(this).mouseenter( function() {
							$(domHelpDisplayer).empty().append(thisDomHelp);
						}).mouseleave( function() {
							$(thisDomHelp).remove();
						})
					}					
				});*/

			}
			self.lightbox.openPanel();
			if (!self.slidersInitialised) {
				self.slidersInitialised = true;
				self.initialiseAdminValueSliders();
			}
			self.setFieldValues(); // We want to do this everytime we open the panel to ensure that we have the latest data
			return false;
		});
		//$("#tl-ah-timeline-3d-settings").click();
		return self;	
	},
	setFieldValues: function() {
		var self = this;	
	},
	initialiseAdminValueSliders: function() {
		var self = this;
		$(self.domRoot ).find(".ft-component-value-slider").each( function() {
			
			AJKValueSlider.createAdminSlider({
				domEl: this,
				startDragCallback: function() {
					$(self.lightbox.domFade).css({ display: "none" });
				},
				endDragCallback: function() {
					$(self.lightbox.domFade).css({ display: "block" });
				}
			});
			
			/*var domInput = $(this).find("input").get()[0];
			var rangeStr = $(domInput).attr("range");
	
			var insertHTML = '<div class="ft-cvs-holder">';
			insertHTML += '<div class="ft-cvs-bar"></div>';
			insertHTML += '<div class="ft-cvs-dragger"></div>';
			insertHTML += '</div>';
			
			var domSlider = $(insertHTML).get()[0];
			
			var domInputHolder = $(this).find(".tl-ah-input").get()[0];
			$(domInputHolder).append(domSlider);
			
			var draggerRange = parseInt($(domSlider).css("width"));

			new AJKValueSlider({
				domRoot: domSlider,
				domDragger: $(domSlider).find(".ft-cvs-dragger").get()[0],
				name: $(domInput).attr("name"),
				range: {
					min: parseFloat(rangeStr.split(",")[0]),
					max: parseFloat(rangeStr.split(",")[1]) 	
				},
				callback: function(data) {
					$(domInput).val(data.newVal);
					$(domInput).blur();
				},
				limitFunc: function() {
					var limit = {
						minX: 0,
						maxX: draggerRange,
						minY: 5,
						maxY: 5
					}
					return limit;			
				}
			}).init();*/
		
		});
	},
	generate3DVarString: function() {
		var self = this;
		var tl = self.timeline3D;
		var dec = AJKHelpers.convertNumToXDecimalPlaces;
		return tl.status+","+tl.color+","+dec({ num: tl.zoom, x: 5 })+","+tl.panelSize+","+dec({ num: tl.vanishTop, x: 5 })+","+dec({ num: tl.endToScreenRatio, x: 5 })+","+tl.direction+","+tl.numCols+","+dec({ num: tl.bgFade, x: 5 });
	},
	setupVerification: function() {
		var self = this;
		self.verifier = new AJKVerifier({
			domRootEl: self.domRoot,
			cancelFunc: function() {
			},
			revertFunc: function() {
				self.verifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {
                self.timeline.settings3d = self.generate3DVarString();
				
				self.verifier.saveFieldValues();
				self.verifier.disableSaveAndRevert();
                self.controller.updateTimelineSavedStatus({ status: "save-needed" });
				
			}
		}).init();

		self.verifier.onChangeCallback = function(data) {
			switch (data.fieldName) {
				case "timeline3DNumCols":
					var val = parseInt(data.fieldValue);
					if (val != self.timeline3D.numCols) { 
						self.timeline3D.numCols = parseInt(data.fieldValue);
						self.mainController.selected3DView.updateStoryColPositions();
					}
				break;
				case "timeline3DColor":	
					self.timeline3D.color = data.fieldValue;
				break;
				case "timeline3DZoom":	
					self.timeline3D.zoom = Math.pow(parseFloat(data.fieldValue),2);
				break;
				case "timeline3DPanelSize":	
					self.timeline3D.panelSize = parseInt(data.fieldValue,10);
				break;
				case "timeline3DVanishTop":	
					self.timeline3D.vanishTop = parseFloat(data.fieldValue);
				break;
				case "timeline3DEndToScreenRatio":	
					self.timeline3D.endToScreenRatio = parseFloat(data.fieldValue);
				break
				case "timeline3DDirection":
					self.timeline3D.direction = parseInt(data.fieldValue,10);
				break;
				case "timelineBGFade":
					self.timeline3D.bgFade = parseFloat(data.fieldValue);
				break;
				case "timeline3DStatus":
					var newStatus = parseInt(data.fieldValue);
					if (newStatus != self.timeline3D.status) { 
						self.timeline3D.status = newStatus;
						var view3d = self.mainController.selected3DView;
						view3d.updateButtonState();
						if ((newStatus == 2 && !view3d.active) || (newStatus < 2 && view3d.active)) {
							$(view3d.domLaunchButton).click();
						}
					}
				break;
				default:
				break;
			}
			if (data.fieldName == "timeline3DZoom" || data.fieldName == "timeline3DDirection") {
				self.mainController.selected3DView.redisplayAfterDataChange();
			}
			else {
				self.mainController.selected3DView.redisplay();
			}

		}

		self.verifier.hideCancelButton();
		self.verifier.showRevertButton();
		self.verifier.disableSaveAndRevert();
		
	},
	setFieldValues: function() {
		var self = this;
		self.verifier.setFieldValues({
			fieldValues: {
				timeline3DNumCols: self.timeline3D.numCols,
				timeline3DZoom: Math.sqrt(self.timeline3D.zoom),
				timeline3DPanelSize: self.timeline3D.panelSize,
				timeline3DVanishTop: self.timeline3D.vanishTop,
				timeline3DEndToScreenRatio: self.timeline3D.endToScreenRatio,
				timeline3DDirection: self.timeline3D.direction,
				timeline3DStatus: self.timeline3D.status,
				timeline3DColor: self.timeline3D.color,
				timelineBGFade: self.timeline3D.bgFade
			}

		});

		self.verifier.saveFieldValues();
		self.verifier.disableSaveAndRevert();		
	}
}


/* TLAdminTagController */
var TLAdminTagController = function(data) {
	var self = this;
	self.controller = data.controller;
	self.user = self.controller.user;
	self.mainController = self.controller.mainController;
	self.adminAlertController = self.controller.adminAlertController;
	self.timeline = self.controller.timeline;
	self.eventCatcherController = self.controller.eventCatcherController
	self.domStoryTagsForm = $("#tl-tab-selected-story-tags").get()[0];
	self.domTagsTab = $("#tab-my-selected-timeline-tags").get()[0];
	self.domTagsForm = $("#tl-ah-tags-form").get()[0];
	self.domSelectedTagTitle = $("#tl-ah-selected-tag-title").get()[0];
	self.domStoryTagSelect = $("#tl-ah-story-tag-select").get()[0];
	self.domCreateNewTagButton = $(self.domStoryTagsForm).find(".launch-tag-panel").get()[0];
	self.tagsListController = "";
	self.selectedTagItem = "";
	self.tagsFormVerifier = "";
	self.tagLimit = 50;
	
}

TLAdminTagController.prototype = {
	init: function() {
		var self = this;

		$(self.domCreateNewTagButton).click( function() {
			if (self.user.accountType == "Standard") {
				self.controller.promotionPanel.show({oneOffClass: "tl-pp-show-requires-premium-account" });

			}
			else {
				self.launchCreateTagLightbox();
			}
			return false;
		});
				
		self.initVerifiers();
		
		return self;		
	},
	launchCreateTagLightbox: function() {
		var self = this;
		if (!self.createTagLightbox) {
			self.setupCreateTagLightbox();
		}
		self.updateTimelineTagList();
		self.createTagLightbox.openPanel();
		$(self.domTimelineTagTitleField).focus();
	},
	setupCreateTagLightbox: function() {
		var self = this;
		var domContent = $("#tl-ah-create-tag-form-content .tl-ah-form-holder").get()[0];
		self.domTimelineTagTitleField = $(domContent).find("#tl-ah-tag-creation-field-title").get()[0];
		
		$(domContent).find(".ajk-verifier-submit").click( function() {
			self.createNewTag({ title: $(self.domTimelineTagTitleField).val() });
			return false;
		});
		
		self.createTagLightbox = new TLAdminLightbox({
			domClass: "tl-ah-create-tag-panel",
			title: "Create/delete tags",
			intro: "Manage tags for this timeline", /*TLConfigText["advancedSettings_intro"],*/
			domContent: domContent,
			activateAlert: true
		}).init();	
		
		self.domTimelineTagsContainer = $(domContent).find(".tl-ah-timeline-tag-holder").get()[0];
		
		self.domTagLimitMessage = $(domContent).find("#tl-ah-timeline-tag-limit-message").get()[0];
		
		$(self.domTimelineTagsContainer).click( function(e) {
			if ($(e.target).hasClass("remove-tag")) {
				var key = $(e.target).parent().attr("key");
				var tag = self.timeline.tagsByKey[key];
				if (tag) {
					// May want to present an alert to confirm first

					// Delete confirmation
					self.createTagLightbox.alert.displayMessage({
						headline: TLConfigText["tag_deleteTag_headline"],
						body: '<p>'+TLConfigText["tag_deleteTag_message"]+' “'+tag.text+'”?</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
							action: function() {}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
							action: function() {
								// Delete the story
								self.deleteTimelineTag({ tag: tag });
							}	
						}]	
					});

				} 
			}
			return false;
		});


	},
	updateTimelineTagList: function() {
		var self = this;
		
		var tags = self.getTags();
		
		var iH = "";
		$.each( tags, function() {
			iH += self.generateHTMLForStoryTag({ tag: this });
		});
		
		$(self.domTimelineTagsContainer).empty().append(iH);
		
		self.numTags = tags.length;
		
	},
	createNewTag: function(data) {
		var self = this;
		var tagTitle = data.title;
		
		if (self.numTags >= self.tagLimit) {
			// Flash limit
			AJKHelpers.flashDomEl({ domEl: self.domTagLimitMessage });	
		}
		else if (tagTitle && !self.creatingNewTag) {
			self.creatingNewTag = true;
			var newTagItem = {
				id: "awaitingId",
				text: tagTitle
			}
			self.controller.updateContentPanel({ story: self.controller.selectedStory });

			newTagItem.id = theTLCreateIdCounters.tag++;
			self.mainController.addNewTag({ tag: newTagItem });
			self.tagsHaveChanged();
			$(self.domTimelineTagTitleField).val("").focus();
			self.createTagLightbox.repositionAfterContentChange();
			self.creatingNewTag = false;
			self.controller.updateTimelineSavedStatus({ status: "save-needed" });
		}
		else {
			// display error	
			$(self.domTimelineTagTitleField).focus();
		}

	},
	deleteTimelineTag: function(data) {
		var self = this;

		var tag = data.tag;

		var vars = {};
		vars["id"] = tag.id;
		vars["timelineId"] = self.timeline.id;
		var action = "/admin/deletetag/";
		//var action = "/"; // remove this
		
		//self.removeTagFromStoryTagForm({ tag: tag });

		self.timeline.tags = AJKHelpers.removeItemFromArray({anArray: self.timeline.tags, item: tag });
		self.timeline.tagsByKey[tag.key] = "";

		self.tagsHaveChanged();
		self.controller.updateContentPanel({ story: self.controller.selectedStory });
		self.createTagLightbox.repositionAfterContentChange();

		self.controller.updateTimelineSavedStatus({ status: "save-needed" });
	},
	tagsHaveChanged: function() {
		var self = this;
		//self.tagsListController.resetWithNewListItems({ listItems: self.getTags() });
		self.populateTagsFromStoryTagsField();
		self.updateStoryTagLists();
		self.updateTimelineTagList();
	},
	getTags: function() {
		var self = this;
		var retArray = [];
		$.each( self.timeline.tags, function() {
			if (!this.autoGenerated) {
				retArray.push(this);	
			}
		});
		return retArray;
	},
	initVerifiers: function() {
		var self = this;	

		self.storyTagsFormVerifier = new AJKVerifier({
			domRootEl: self.domStoryTagsForm,
			revertFunc: function() {
				self.storyTagsFormVerifier.restoreSavedFieldValues();
				self.populateTagsFromStoryTagsField();
				self.eventCatcherController.deactivate();

			},
			submitFunc: function(data) {
				if (!self.controller.selectedStory.id) {
					//alert("We need to ensure the story has been created at this point.");	
				}

				self.controller.displayStandardSavingAlertMessage();

				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["storyId"] = self.controller.selectedStory.id;
				vars["tags"] = vars["storyTags"];
				
				self.controller.selectedStory.tags = vars["tags"];
				self.controller.selectedStory.initialiseTags();
				
				self.controller.updateContentPanel({ story: self.controller.selectedStory });

				self.storyTagsFormVerifier.saveFieldValues();
				self.storyTagsFormVerifier.disableSaveAndRevert();
				self.eventCatcherController.deactivate();

				self.controller.updateTimelineSavedStatus({ status: "save-needed" });
				self.adminAlertController.fadeOut();

			}
		}).init();
	},
	storyWasSelected: function() {
		var self = this;

		self.storyTagsFormVerifier.setFieldValues({
			fieldValues: {
				storyTags: self.controller.selectedStory.tags	
			}
		});
		self.storyTagsFormVerifier.saveFieldValues();
		self.storyTagsFormVerifier.disableSaveAndRevert();
		self.initStoryTagsPanel();
		self.populateTagsFromStoryTagsField();
			
	},
	storyTagsPanelOpened: function() {
		var self = this;

		self.eventCatcherController.setupAction({
			domCutOffEl: self.domStoryTagsForm,
			clickFunc: function() {
				self.adminAlertController.displayMessage({
					headline: TLConfigText["storyTags_unsavedChanges_headline"],
					body: '<p>'+TLConfigText["storyTags_unsavedChanges_message"]+'</p>',
					buttons: [{
						html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
						action: function() {
							// Save the story tags
							self.storyTagsFormVerifier.fireButton({ buttonType: "save" });
						}	
					},{
						html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
						action: function() {
							// Revert the story tags
							self.storyTagsFormVerifier.fireButton({ buttonType: "revert" });
						}	
					}]	
				});
			}
		});

		self.storyTagsFormVerifier.onChangeCallback = function(data) {
			if (self.storyTagsFormVerifier.areValuesDifferentFromSavedValues()) {
				self.eventCatcherController.activate();
			}
			else {
				self.eventCatcherController.deactivate();
			}
		}


	},
	initStoryTagsPanel: function() {
		var self = this;	
		if (self.storyTagsPanelInitialised) {
			return;
		}
		self.domStoryTagSelect = $(self.domStoryTagsForm).find(".tl-ah-story-tag-select-holder select").get()[0];
		self.storyTagsPanelInitialised = true;
		
		self.domStoryTagsContainer = $(self.domStoryTagsForm).find(".tl-ah-story-tag-holder").get()[0];
		
		/*$(self.domStoryTagAddButton).click( function() {
			self.addStoryTag();
			return false;
		});*/
		
		$(self.domStoryTagsContainer).click( function(e) {
			if ($(e.target).hasClass("remove-tag")) {
				var key = $(e.target).parent().attr("key");
				var tag = self.timeline.tagsByKey[key];
				if (tag) {
					self.removeTagFromStoryTagForm({ tag: tag });
				} 
			}
			return false;
		});
		$(self.domStoryTagSelect).change( function() {
			self.addStoryTag();
			self.updateStoryTagLists();
		});
		
		self.updateStoryTagLists();
	},
	removeTagFromStoryTagForm: function(data) {
		var self = this;
		var tag = data.tag;
		
		var cTags = self.getArrayOfTagsFromIdList({ 
			list: self.storyTagsFormVerifier.getFieldValueFromName({ fieldName: "storyTags" }) 
		});
		var tagIds = "";
		$.each(cTags, function() {
			var tTag =this;
			if (tTag != tag) {
				tagIds = (tagIds) ? tagIds+"," : "";
				tagIds += tTag.id;
			}
		});
		
		self.storyTagsFormVerifier.setFieldValues({
			fieldValues: {
				"storyTags": tagIds
			},
			forceChangeEvent: "auto"
		});
		
		self.populateTagsFromStoryTagsField();

	},
	getDomStoryFormTagFromTag: function(data) {
		var self = this;
		var tagKey = data.tag.key;
		var domEl = "";
		$(self.domStoryTagsContainer).find(".story-tag").each( function() {
			var thisKey = $(this).attr("key");
			if (thisKey == tagKey) {
				domEl = this;
				return false;
			}
		}); 
		return domEl;
	},
	isTagAlreadyInStoryTagList: function(data) {
		var self = this;
		var tag = data.tag;
		found = false;
		var cTags = self.getArrayOfTagsFromIdList({ 
			list: self.storyTagsFormVerifier.getFieldValueFromName({ fieldName: "storyTags" }) 
		});
		$.each(cTags, function() {
			var cTag = this;
			if (tag == cTag) {
				found = true;
				return false; // exit loop	
			} 
		});
		return found;
	},
	getArrayOfTagsFromIdList: function(data) {
		var self = this;
		var list = data.list;
		var retArr = [];
		if (list && list.split) {
			var lIds = list.split(",");
			$.each(lIds, function() {
				var key = theTLMainController.tagsKeyPrefix+this;
				var tag = self.timeline.tagsByKey[key];
				if (tag) {
					retArr.push(tag);	
				}
			});
		}
		return retArr;
	},
	populateTagsFromStoryTagsField: function() {
		var self = this;
		var tags = self.getArrayOfTagsFromIdList({
			list: self.storyTagsFormVerifier.getFieldValueFromName({ fieldName: "storyTags" })	
		});
		var ins="";
		$.each(tags, function() {
			var thisTag = this;
			ins+=self.generateHTMLForStoryTag({ tag: thisTag });
		});
		$(self.domStoryTagsContainer).empty().append(ins);
	},
	addStoryTag: function() {
		var self = this;
		var tagKey = $(self.domStoryTagSelect).val();
		var tag = self.timeline.tagsByKey[tagKey];
		if (tag && !self.isTagAlreadyInStoryTagList({ tag: tag })) {
			$(self.domStoryTagsContainer).append(self.generateHTMLForStoryTag({ tag: tag }));

			var prepend = self.storyTagsFormVerifier.getFieldValueFromName({ fieldName: "storyTags" })
			prepend = (prepend) ? prepend+"," : "";
			
			self.storyTagsFormVerifier.setFieldValues({
				fieldValues: {
					"storyTags": prepend+tag.id
				},
				forceChangeEvent: "auto"
			});

		}
		else if (tag) {
			// Flash the tag
			var domEl = self.getDomStoryFormTagFromTag({ tag: tag });
			AJKHelpers.flashDomEl({ domEl: domEl });	
		}
	},
	generateHTMLForStoryTag: function(data) {
		var self = this;
		var tag = data.tag;
		
		return '<div key="'+tag.key+'" class="story-tag">'+tag.text+'<a class="remove-tag" href="#">x</a></div>';
	},
	generateStoryTagLists: function() {
		var self = this;

		var insertHTML = "";		
		insertHTML += '<option value="choose-tag" selected="selected">'+TLConfigText["storyTags_choose_tag_to_add"]+'</option>';
		$.each(self.timeline.tags, function() {
			if (!this.autoGenerated) {
				insertHTML += '<option value="'+this.key+'">'+this.text+'</option>';
			}
		});

		$(self.domStoryTagSelect).empty().append(insertHTML);
	},
	updateStoryTagLists: function() {
		var self = this;
		self.generateStoryTagLists();
	},
	updateTagValue: function(data) {
		var self = this;
		var fieldName = data.fieldName;
		var fieldValue = data.fieldValue;
		self.selectedTagItem[fieldName] = fieldValue;

		if (fieldName == "text") {
			$(self.domSelectedTagTitle).text(self.selectedTagItem.text);
			$("#tl-tag-item-"+self.selectedTagItem.id).text(self.selectedTagItem.text);
		}
	}
}


/* TLAdminSpanController */
var TLAdminSpanController = function(data) {
	var self = this;
	self.controller = data.controller;
	self.mainController = self.controller.mainController;
	self.spanController = self.mainController.spanController;
	self.adminAlertController = self.controller.adminAlertController;
	self.timeline = self.controller.timeline;
	self.eventCatcherController = self.controller.eventCatcherController
	self.domSpansTab = $("#tab-my-selected-timeline-spans").get()[0];
	self.domSpansForm = $("#tl-ah-spans-form").get()[0];
	self.domSelectedSpanTitle = $("#tl-ah-selected-span-title").get()[0];
	self.spansListController = "";
	self.selectedSpanItem = "";
	self.spansFormVerifier = "";
	self.slidersInitialised = false;
	
}

TLAdminSpanController.prototype = {
	init: function() {
		var self = this;


		$(self.controller.domRoot).find("#tl-ah-create-new-span-button a").click( function() {
			self.createNewSpanItem();
			return false;
		});

		self.setupSpanList();
		self.initVerifiers();
		
		/*setTimeout( function() {
			$("#tl-spans-tab-menu-item").click();
		},100);*/

		return self;		
	},
	initVerifiers: function() {
		var self = this;	
		
		self.spansFormVerifier = new AJKVerifier({
			domRootEl: self.domSpansForm,
			cancelFunc: function() {
				self.deleteSpanItem({spanItem: self.selectedSpanItem});
			},
			revertFunc: function() {
				self.spansFormVerifier.restoreSavedFieldValues();
			},
			submitFunc: function(data) {

				self.controller.displayStandardSavingAlertMessage();

				data.fieldData["start"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["start"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});

				data.fieldData["end"] = AJKHelpers.formatDate({
					date: Date.parse(data.fieldData["end"]),
					formatString: "YYYY-MM-DD HH:mm:ss",
					forceFullDate: true,
					language: "base"
				});
				
				data.fieldData["colorOpacity"] = parseInt(data.fieldData["colorOpacity"],10);

				var vars = data.fieldData;
				vars["timelineId"] = self.timeline.id;
				vars["id"] = self.selectedSpanItem.id;

				// May need to update things like image here. Check
				//self.selectedSpanItem.title = vars["title"];

				var relatedSpanItem = self.selectedSpanItem;
				
				var newItem = (self.selectedSpanItem.id == "awaitingId") ? true : false; 
								
				// If image has changed, we may need to update the image
				
				self.spanController.refresh();
				self.selectedSpanItem.refresh();

				self.spansFormVerifier.saveFieldValues();
				self.spansFormVerifier.hideCancelButton();
				self.spansFormVerifier.showRevertButton();
				self.spansFormVerifier.disableSaveAndRevert();
				
				self.eventCatcherController.deactivate();

				if (newItem) {
					var spanId = theTLCreateIdCounters.span++;
					relatedSpanItem.id = spanId;
					if (self.selectedSpanItem == relatedSpanItem) { 
						self.spansListController.resetWithNewListItems({ listItems: self.getSpans() });
						self.spansListController.showAndSelectListItem({ listItem: relatedSpanItem, instantly: true });
					}
				}
				else {
					// Sort the categories and redisplay
					self.spanController.sortSpans();
					self.spansListController.resetWithNewListItems({ listItems: self.getSpans() });
					if (self.selectedSpanItem == relatedSpanItem) { 
						self.spansListController.showAndSelectListItem({ listItem: relatedSpanItem, instantly: true });
					}
				}

				self.controller.updateTimelineSavedStatus({ status: "save-needed" });
				self.adminAlertController.fadeOut();
				
			}
		}).init();

	},
	setupSpanList: function() {
		var self = this;
		
		$("#tl-spans-tab-menu-item").click( function() {
			if (!self.spansListController) {
				self.spansListController = new AJKScrollableListController({
					domRoot: $("#tab-my-selected-timeline-spans .ajk-cs-carousel").get()[0],
					domStage: $("#tab-my-selected-timeline-spans .ajk-cs-carousel-stage").get()[0],
					listItems: self.getSpans(),
					createDomListItemFunc: function(data) {
						var spanItem = data.listItem;				
						var extraClass = (spanItem.uneditable) ? " tl-ah-list-item-uneditable" : "";
						var insertHTML = '<div spanId="'+spanItem.id+'" class="tl-ah-list-item'+extraClass+'">';
						insertHTML+='<div class="tl-ah-col-1">';
						insertHTML+='<p id="tl-span-item-'+spanItem.id+'">'+spanItem.title+'</p>';
						insertHTML+='</div>';
						insertHTML+='<div class="tl-ah-col-2">';
						insertHTML+='<a href="#">'+TLConfigText['adminBasic_Edit']+'</a> | <a class="tl-ah-li-delete" href="#">'+TLConfigText['adminBasic_Delete']+'</a>';
						insertHTML+='</div>';
						insertHTML+='</div>';					
						return $(insertHTML).get()[0];
					},
					listItemSelectClass: "tl-ah-list-item-selected",
					itemWasClickedFunc: function(data) {
						var spanItem = data.listItem;

						if (spanItem.uneditable) {
							self.adminAlertController.displayMessage({
								headline: TLConfigText["feedSpan_cantEdit_headline"],
								body: '<p>'+TLConfigText["feedSpan_cantEdit_message"]+'</p>',
								buttons: [{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
									action: function() {}	
								}]
							});
							return;	
						}

						var clickedElClass = data.clickedElClass;
						if (clickedElClass.indexOf("tl-ah-li-delete") != -1) {
							// delete the clickedEl;

							self.adminAlertController.displayMessage({
								headline: TLConfigText["span_deleteSpan_headline"],
								body: '<p>'+TLConfigText["span_deleteSpan_message"]+' “'+spanItem.title+'”?</p>',
								buttons: [{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_No']+'</a>',
									action: function() {}	
								},{
									html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Yes']+'</a>',
									action: function() {
										// Delete the story
										self.deleteSpanItem({ spanItem: spanItem });
									}	
								}]	
							});

						}
						else {
							self.selectSpanItem( { spanItem: spanItem });
						}
					},
					getKeyForListItem: function(data) {
						var spanItem = data.listItem;
						return spanItem.id;
					},
					getPositionForListItem: function(data) {
						var spanItem = data.listItem;	
						return spanItem.listPosition;
					}
				}).init();
			}
		});
	},
	createNewSpanItem: function() {
		var self = this;
		
		if (self.spanController.spans.length >= 50) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["timelineSpansForm_max_alert_title"],
				body: '<p>'+TLConfigText["timelineSpansForm_max_alert_message"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				}]
			});
			return;	
		}
		else if (self.mainController.user.accountType == "Standard" && self.spanController.spans.length >= 5) {
			self.adminAlertController.displayMessage({
				headline: TLConfigText["timelineSpansForm_max_alert_title_free"],
				body: '<p>'+TLConfigText["timelineSpansForm_max_alert_message_free"]+'</p>',
				buttons: [{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Continue']+'</a>',
					action: function() {}	
				},{
					html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Upgrade']+'</a>',
					action: function() {
						self.controller.promotionPanel.show();
					}	
				}]
			});
			return;	
		}
		
		var vContr = theTLMainController.selectedView;
		startDate = (self.timeline.markerSpacing=="equal") ? vContr.getEqualSpacingDateFromStandardDate({ aDate: theTLSettings.currentDate }) : theTLSettings.currentDate;
		var endDate = self.getNewEndDateForStartDate({ startDate: startDate });
		
		var newSpanItem = self.spanController.createNewSpan({
			id: "awaitingId",
			title: TLConfigText["span_New_span"],
			start: AJKHelpers.formatDate({ date: startDate, formatString: "YYYY-MM-DD HH:mm:ss", language: "base" }),
			end: AJKHelpers.formatDate({ date: endDate, formatString: "YYYY-MM-DD HH:mm:ss", language: "base" }),
			color: theTLMainController.timeline.mainColour,
			image: "",
			imageCredit: "",
			style: 1,
			textColor: "ffffff",
			colorOpacity: 70,
			showInSlider: 1,
			showText: 0
		});
		self.spanController.sortSpans();
		self.spanController.updateSpansInDom();
		self.spanController.dealWithMainImageCaption();


		self.spansListController.addListItemAtIndex({
			listItem: newSpanItem,
			index: "last"
		});
		self.spansListController.showAndSelectListItem({ listItem: newSpanItem });
		self.selectSpanItem({ spanItem: newSpanItem });
	},
	deleteSpanItem: function(data) {
		var self = this;

		var spanItem = data.spanItem;
		self.spansListController.removeListItem({
			listItem: spanItem
		});

		var vars = {};
		vars["id"] = spanItem.id;
		vars["timelineId"] = self.timeline.id;
		
		if (self.selectedSpanItem == spanItem) {
			self.hideSpansForm();
			self.selectedSpanItem = "";
		}
		
		self.spanController.spans = AJKHelpers.removeItemFromArray({anArray: self.spanController.spans, item: spanItem });
		self.spanController.spansByKey[spanItem.key] = "";
		self.spanController.sortSpans();
		self.spanController.updateSpansInDom();

		spanItem.destroy();

		self.eventCatcherController.deactivate();
		self.spanController.refresh();

		self.updateTimelineSavedStatus({ status: "save-needed" });

	},
	hideSpansForm: function() {
		var self = this;		
		$(self.domSpansForm).css({ display: "none" });
	},
	getSpans: function() {
		var self = this;
		var retArray = [];
		$.each( self.spanController.spans, function() {
			if (!this.autoGenerated) {
				retArray.push(this);	
			}
		});
		return retArray;
	},
	spanPanelOpened: function() {
		var self = this;
		
		self.controller.helpController.setBaseHelpByName({ baseName: "default" });

		self.eventCatcherController.setupAction({
			domCutOffEl: self.domSpansForm,
			clickFunc: function() {
				if (self.selectedSpanItem.id != "awaitingId") { // Existing span
					self.adminAlertController.displayMessage({
						headline: TLConfigText["span_unsavedChanges_headline"],
						body: '<p>'+TLConfigText["span_unsavedChanges_message1"]+' “'+self.selectedSpanItem.title+'”. '+TLConfigText["span_unsavedChanges_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the span
								self.spansFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Revert']+'</a>',
							action: function() {
								// Revert the span
								self.spansFormVerifier.fireButton({ buttonType: "revert" });
							}	
						}]	
					});
				}
				else { // New span
					self.adminAlertController.displayMessage({
						headline: TLConfigText["span_unsavedSpan_headline"],
						body: '<p>'+TLConfigText["span_unsavedSpan_message1"]+' “'+self.selectedSpanItem.title+'”. '+TLConfigText["span_unsavedSpan_message2"]+'</p>',
						buttons: [{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Update']+'</a>',
							action: function() {
								// Save the span
								self.spansFormVerifier.fireButton({ buttonType: "save" });
							}	
						},{
							html: '<a href="#" class="rt-button-4 rt-button-align-right">'+TLConfigText['adminBasic_Delete']+'</a>',
							action: function() {
								// Cancel the new span
								self.spansFormVerifier.fireButton({ buttonType: "cancel" });
							}	
						}]	
					});
				}
				
			}
		});

	},
	initialiseAdminValueSliders: function() {
		var self = this;
		$(self.domSpansForm).find(".ft-component-value-slider").each( function() {
			AJKValueSlider.createAdminSlider({
				domEl: this
			});
		});
	},
	animateTimelineToSpan: function(data) {
		var self = this;
		var span = data.span;
		var sStyle = span.getEffectiveStyle();
		var vContr = theTLMainController.selectedView;

		if (sStyle == 2) {
			var lOff = -span.block.startPos-(0.5 * theTLMainController.viewContentSize.width);
			var sDate = vContr.getDateFromLeftOffset({ leftOffset: -lOff });
		}
		else {
			var sDate = vContr.getDateFromLeftOffset({ leftOffset: span.block.startPos + (span.block.endPos-span.block.startPos)/2 });

		}
		sDate = theTLSettings.limitDateToRange({ aDate: sDate });
		
		theTLSettings.setCurrentDate({
			date: sDate,
			animate: true
		});
	},
	getNewEndDateForStartDate: function(data) {
		var self = this;
		//getEquallySpacedOffsetForDate
		// May need to deal with equal spacing
		var newSpanWidth = 600;
		var vContr = theTLMainController.selectedView;
		var startDate = data.startDate;
		var dDiffInMS = -(vContr.getDateFromLeftOffset({ leftOffset: 0 }) - vContr.getDateFromLeftOffset({ leftOffset: newSpanWidth }));
		var retDate = new Date();
		retDate.setTime(dDiffInMS+startDate.getTime());
		return retDate;
	},
	selectSpanItem: function(data) {
		var self = this;
		var spanItem = data.spanItem;
		var oldSpanItem = self.selectedSpanItem;
		self.selectedSpanItem = spanItem;
		self.spansListController.selectListItem({ listItem: spanItem });
		
		self.animateTimelineToSpan({ span: spanItem });
		if (self.selectedSpanItem != oldSpanItem) {
			$(self.domSelectedSpanTitle).text(self.selectedSpanItem.title);
			
			$(self.domSpansForm).css({ display: "block", visibility: "hidden" });
			
			if (!self.slidersInitialised) {
				self.slidersInitialised = true;
				self.initialiseAdminValueSliders();
			}

			$(self.domSpansForm).css({ visibility: "visible" });

			self.spansFormVerifier.onChangeCallback = "";
			self.spansFormVerifier.onKeyUpCallback = "";
			
			// animate the timeline to the start of this span
			
			self.spansFormVerifier.setFieldValues({
				fieldValues: {
					title: spanItem.title,
					start: AJKHelpers.formatDate({ formatString: "DD MMM YYYY HH:mm:ss", date: spanItem.start, language: "base" }),
					end: AJKHelpers.formatDate({ formatString: "DD MMM YYYY HH:mm:ss", date: spanItem.end, language: "base" }),
					color: spanItem.color,
					image: spanItem.image,
					imageCredit: spanItem.imageCredit,
					imageDataUri: spanItem.imageDataUri,
					style: spanItem.style,
					textColor: spanItem.textColor,
					colorOpacity: spanItem.colorOpacity,
					showInSlider: spanItem.showInSlider,
					showText: spanItem.showText
				}
			});

			if (self.selectedSpanItem.id != "awaitingId") {
				self.spansFormVerifier.hideCancelButton();
				self.spansFormVerifier.showRevertButton();
				self.spansFormVerifier.disableSaveAndRevert();
				self.spansFormVerifier.saveFieldValues();
			}
			else {
				// span has no ID so has not been saved yet so we display the cancel rather than the revert button
				self.spansFormVerifier.hideRevertButton();
				self.spansFormVerifier.showCancelButton();
				self.spansFormVerifier.enableSaveAndRevert();
				self.eventCatcherController.activate();
			}

			self.spansFormVerifier.onChangeCallback = function(data) {
				if (data.fieldName == "start") {
					var oldStart = AJKHelpers.cloneDate({ date: spanItem.start });
					self.updateSpanValue(data);
					self.syncSpanStartEndDates({ oldStart: oldStart });					
				}
				else {
					self.updateSpanValue(data);
				}

				if (self.spansFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
				
			}
			self.spansFormVerifier.onKeyUpCallback = function(data) {
				if (data.fieldName == "title" || data.fieldName == "imageCredit") {
					self.updateSpanValue(data);
				}
				if (self.spansFormVerifier.areValuesDifferentFromSavedValues()) {
					self.eventCatcherController.activate();
				}
				else {
					self.eventCatcherController.deactivate();
				}
			}

		}
	},
	syncSpanStartEndDates: function(data) {
		var self = this;
		var oldStart = data.oldStart;
		var start = Date.parse(self.spansFormVerifier.getFieldValueFromName({ fieldName: "start" }));
		var end = Date.parse(self.spansFormVerifier.getFieldValueFromName({ fieldName: "end" }));
		if (!start || !end) {
			return;	
		}
		if (end.getTime() < start.getTime()) {
			var newEnd = AJKHelpers.formatDate({
				formatString: "DD MMM YYYY HH:mm:ss",
				date: start,
				language: "base"
			});
			
			self.spansFormVerifier.setFieldValues({
				fieldValues: {
					end: newEnd
				},
				forceChangeEvent: true
			});
		}
	},
	updateSpanValue: function(data) {
		var self = this;
		var fieldName = data.fieldName;
		var fieldValue = data.fieldValue;

		if (fieldName == "start" || fieldName == "end") {
			var pDate = Date.parse(fieldValue);
			if (!pDate) {
				return;
			}
			self.selectedSpanItem[fieldName] = pDate;
			self.selectedSpanItem.updateDates();
			self.spanController.sortSpans();
			self.spanController.updateSpansInDom();
			self.selectedSpanItem.refresh();
			if (fieldName == "start") {
				self.animateTimelineToSpan({ span: self.selectedSpanItem });
			}
		}
		else {
			self.selectedSpanItem[fieldName] = fieldValue;
		}
		
		if (fieldName == "title") {
			$(self.domSelectedSpanTitle).text(self.selectedSpanItem.title);
			$("#tl-span-item-"+self.selectedSpanItem.id).text(self.selectedSpanItem.title);
			self.selectedSpanItem.updateTitle();
		}
		else if (fieldName == "color") {
			self.selectedSpanItem.updateColor();
		}
		else if (fieldName == "colorOpacity") {
			self.selectedSpanItem.updateColorOpacity();
		}
		else if (fieldName == "textColor") {
			self.selectedSpanItem.updateTextColor();
		}
		else if (fieldName == "showText") {
			self.selectedSpanItem.updateShowText();
			self.selectedSpanItem.positionBlockText();
		}
		else if (fieldName == "showInSlider") {
			self.selectedSpanItem.updateShowInSlider();
		}
		else if (fieldName == "imageCredit") {
			self.selectedSpanItem.updateImageCredit();
		}
		else if (fieldName == "image") {
            self.selectedSpanItem.imageDataUri = "";
            self.spansFormVerifier.setFieldValues({
                 fieldValues: {
                     imageDataUri: ""
                 }
            });
			self.selectedSpanItem.updateImage();
		}
		else if (fieldName == "imageDataUri") {
			self.selectedSpanItem.updateImage();
		}
		else if (fieldName == "style") {
			self.selectedSpanItem.updateStyle();
			self.selectedSpanItem.resize();
			self.selectedSpanItem.refresh();
			self.animateTimelineToSpan({ span: self.selectedSpanItem });
		}
		
		
	}
}