/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

if (typeof TLSingleTimelineLicense == "undefined") {
	var TLSingleTimelineLicense = false;
}

var theTLParantWindow, TLTimelineData, initialiseTimeline, theAJKWindowResizeEvent, theTLSettings, theTLMainController, theAJKMouseMoveEvent, theAJKMouseScrollEvent, theAJKButtonPopupController, theAJKKeyEvent,theAJKAjaxController, theTLHashController, theTLCreateIdCounters, theFilePath,tlIsTimelineNew,TLGLOBALIsTouchDevice, TLGLOBALLastTouchEvent, TLGLOBALTouchActive;

var TLDisableMouseScroll = false;

var theTLHooks = "";

var TLConsole = function(input) {
	$(theTLParantWindow.document).find("#console").append("<span>"+input+"</span>");
}

$(document).ready( function() {
	window.addEventListener('message', function(e) {
		if (e.data.type == "file-load") {
            tlIsTimelineNew = e.data.isNew;
                            
            var tlData = preprocessTimelineData({ timelineData: e.data.timelineData });
			eval(tlData);
			processTimelineData({ timelineData: TLTimelineData });
			initialiseTimeline({ timelineData: TLTimelineData, parentWindow: window.parent });
			theFilePath = e.data.filePath;
			if (theFilePath) {
				theTLParantWindow.postMessage({
					type: "save-status",
					saveStatus: "save-not-needed"
				}, '*');
			}
			else {
				theTLParantWindow.postMessage({
					type: "save-status",
					saveStatus: "save-needed"
				}, '*');
			}
		}
		else if (e.data.type == "request-save-data") {
			theTLParantWindow.postMessage({
				type: "save-data",
				saveData: theTLMainController.getTimelineDataAsString(),
				filePath: theFilePath,
				forceNewFile: e.data.forceNewFile
			}, '*');
		}
		else if (e.data.type == "set-file-path") {
			theFilePath = e.data.filePath
		}
	});
                  
    // Here we deal with any potential corruption. New lines etc
    var preprocessTimelineData = function(data) {
        var tlData = data.timelineData;
        tlData = tlData.replace(/\n/g,"");
        tlData = tlData.replace(/\r/g,"");
 
        tlData = tlData.replace( /\x18/g, "" );
        tlData = tlData.replace( /\u2028/g, "" );
        tlData = tlData.replace( /\u2029/g, "" );

        return tlData;
    }
	
	// Here, we reset all the ids to be as low as possible
	// and set the idCounters for stories, categories, media, and feeds
	var processTimelineData = function(data) {
		var timelineData = data.timelineData;
		timelineData.embed = "false";
		
		var catsByOrigId = [];
		var tagsByOrigId = [];
		var categoryCounter = 1;
		var storyCounter = 1;
		var mediaCounter = 1;
		var feedCounter = 1;
		var tagCounter = 1;
		var spanCounter = 1;
		
		if (!timelineData.spans) {
			timelineData.spans = [];
		}
		
		if (!timelineData.tags) {
			timelineData.tags = [];
		}
		
		$.each(timelineData.spans, function() {
			this.id = spanCounter++;
		});
		
		$.each(timelineData.tags, function() {
			tagsByOrigId[""+this.id+""] = this;
			this.id = tagCounter++;
		});
	
		$.each(timelineData.categories, function() {
			catsByOrigId[""+this.id+""] = this;
			this.id = categoryCounter++;
		});
		
		$.each(timelineData.stories, function() {
			this.id = storyCounter++;
			if (this.category && catsByOrigId[""+this.category+""]) {
				this.category = catsByOrigId[""+this.category+""].id;
			}
			$.each(this.media, function() {
				this.id = mediaCounter++;
			});
			
			// Now deal with tags
			
			if (this.tags) {
				var newTagStr = "";
				var tags = this.tags.split(",");
				$.each(tags, function() {
					var oldTagId = this;
					var thisTag = tagsByOrigId[""+oldTagId+""];
					if (thisTag) {
						var newTagId = thisTag.id;
						newTagStr = (newTagStr) ? newTagStr+"," : newTagStr;
						newTagStr += newTagId; 
					}
				});
				this.tags = newTagStr;
			}
		});
	
		$.each(timelineData.feeds, function() {
			this.id = feedCounter++;
		});
	
		theTLCreateIdCounters = {
			category: categoryCounter,
			story: storyCounter,
			media: mediaCounter,
			feed: feedCounter,
			tag: tagCounter,
			span: spanCounter
		}

	}
});

var initialiseTimeline = function(data) {
	TLTimelineData = data.timelineData;
	theTLParantWindow = data.parentWindow;
	
	// Use this for sending a message to save content
	/*setTimeout( function() {
		theTLParantWindow.postMessage({
			type: "file-write",
			timelineData: TLTimelineData
		}, '*');
	},1);*/

	//console.log(JSON.stringify(TLTimelineData));
	
	$.browser.isChrome =  navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
	$.browser.isMac =  navigator.userAgent.toLowerCase().indexOf('macintosh') > -1;
	$.browser.isWindows =  navigator.userAgent.toLowerCase().indexOf('windows') > -1;
	$.browser.isIOS = (navigator.userAgent.toLowerCase().match(/(iphone|ipod|ipad)/)) ? true : false;
	$.browser.isFireFox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
	$.browser.isChrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
	$.browser.isSafari = (!$.browser.isChrome && navigator.userAgent.toLowerCase().indexOf('safari') > -1);
		
	if ($.browser.msie && $.browser.version >= 9) { 
		$.browser.msie = false;
		$.browser.isIE9 = true;
		$.browser.isModernIE = true;
	}
	if ($.browser.msie && $.browser.version == 6) { 
		$.browser.isIE6 = true;
	}
	
	if (window.document.body.style["borderRadius"] === undefined) {
		$("body").addClass("tl-browser-type-advanced-css-unavailable");	
	}
	
	if ($.browser.isIOS) {
		$("body").addClass("tl-browser-type-ios");	
	}
	else if ($.browser.isSafari) {
		$("body").addClass("tl-browser-type-safari");	
	}
	
	theAJKWindowResizeEvent = new AJKWindowResizeEvent().init();
	theAJKMouseMoveEvent = new AJKMouseMoveEvent().init();
	theAJKMouseScrollEvent = new AJKMouseScrollEvent({
		disableScrollPropagation: true //(TLTimelineData.embed == "true")
	}).init();
	theAJKKeyEvent = new AJKKeyEvent().init();
	theAJKWindowBlurEvent = new AJKWindowBlurEvent().init();

	theAJKAjaxController = new AJKAjaxController().init();

	theAJKButtonPopupController = new AJKButtonPopupController({
		domButtons: $("#tl-header .main-menu a").get()
	}).init();

	theTLSettings = new TLSettings().init();
	theTLHashController = new TLHashController().init();
	
	(function() {
		if($("#tl-slider-scale canvas").get()[0].getContext) {
			theTLMainController = new TLMainController();
			theTLMainController.init();
		}
		else {
			var thisFunc = arguments.callee;
			setTimeout(function() {
				thisFunc();
			},5);
		}
	})();
	
	var onmessage = function(e) {
		if (e.data == "mouseup") {
			theAJKWindowBlurEvent.informObserversOfBlur();	
		}
	}
	
	if (typeof window.addEventListener != 'undefined') {  
		window.addEventListener('message', onmessage, false);  
	}
	else if (typeof window.attachEvent != 'undefined') {  
  		window.attachEvent('onmessage', onmessage);  
	}  

	var isTouchDevice = false;

	if (!$.browser.msie && !$.browser.isIE9) {
		isTouchDevice = function() {
  			return 'ontouchstart' in window // works on most browsers 
		}
	}
	
	TLGLOBALIsTouchDevice = (isTouchDevice) ? isTouchDevice() : false;
	TLGLOBALLastTouchEvent = "";
	
	if (TLGLOBALIsTouchDevice) {
		TLGLOBALTouchActive = false;
		var touchHandler = function(event) {
			if (event.target && (event.target.tagName == "INPUT" || event.target.tagName == "TEXTAREA")) {
				return;	
			}

			var touches = event.changedTouches,
	    	first = touches[0],
	        type = "";
	         switch(event.type) {
		        case "touchstart": type = "mousedown"; break;
		        case "touchmove":  type="mousemove"; break;        
		        case "touchend":   type="mouseup"; break;
		        default: return;
	    	}
	    	
	    	if ((event.type == "touchend" || event.type == "touchcancel") && !$.browser.isIOS) {
	    		TLGLOBALTouchActive = false;	
	    	}
	    	else {
	    		TLGLOBALTouchActive = true;
	    	}
	    	
	    	TLGLOBALLastTouchEvent = event.type;

			var simulatedEvent = document.createEvent("MouseEvent");
		    simulatedEvent.initMouseEvent(type, true, true, window, 1, 
		                              first.screenX, first.screenY, 
		                              first.clientX, first.clientY, false, 
		                              false, false, false, 0/*left*/, null);
		                              
		    simulatedEvent.controlSource = "touch";
		
		    first.target.dispatchEvent(simulatedEvent);
		    
		    if (event.type == "touchmove") {
		    	event.preventDefault();
		    }
		}
		
	    document.addEventListener("touchstart", touchHandler, true);
	    document.addEventListener("touchmove", touchHandler, true);
	    document.addEventListener("touchend", touchHandler, true);
	    document.addEventListener("touchcancel", touchHandler, true);    
	}

}