/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

//var TLTranslation = [];

var contentHeight = 0;

var TLDefaultDateFormat = "";


var processStories = function() {

	var lang = $("#printContainer").attr("language");
	var trans = TLTranslation[lang];
	if (trans) {
		AJKHelpers.dateMonthsShortArray = trans.shortMonths;
		AJKHelpers.dateMonthsArray = trans.months;
		AJKHelpers.dateDaySuffixArray = trans.daySuffixes;
		
		TLConfigText['contentPanel_Read_more_text'] = trans.findOutMore;
		TLConfigText['marker_moreButton_text'] = trans.more;
		TLConfigText['basic_By'] = trans.by
		
		TLConfigText['contentPanel_Play_video'] = trans.playVideo;
		TLConfigText['contentPanel_Play_audio'] = trans.playAudio;
		TLConfigText['contentPanel_Close_video'] = trans.closeVideo;
		TLConfigText['contentPanel_Close_audio'] = trans.closeAudio;
	}

	var categoriesById = [];
	$("#category-data-holder .category").each( function() {
		var catId = $(this).attr("catid");
		var catTitle = $(this).text();
		categoriesById["key-"+catId] = {
			id: catId,
			title: catTitle
		}
	});

	var tagsById = [];
	$("#tag-data-holder .tag").each( function() {
		var tagId = $(this).attr("tagid");
		var tagText = $(this).text();
		tagsById["key-"+tagId] = {
			id: tagId,
			text: tagText
		}
	});

	var stories = [];
	var defaultDateFormat = "dd MMM YYYY";
	$("#story-holder .story-block").each( function() {
		var dateFormat = $(this).attr("rel");
		dateFormat = (dateFormat=="auto") ? defaultDateFormat : dateFormat;
		
		var domCategory = $(this).find(".story-category");
		var catId = $(domCategory).text();
		var category = categoriesById["key-"+catId];
		if (category) {
			$(domCategory).empty().append(category.title);
		}
		else {
			$(domCategory).css({ display: "none" });
		}
		
		var domTags = $(this).find(".story-tags");
		var tagInfo = $(domTags).text();
		$(domTags).empty();
		if (tagInfo) {
			var tagIds = tagInfo.split(",");
			$.each(tagIds, function() {
				var tag = tagsById["key-"+this];
				if (tag) {
					$(domTags).append("<span>"+tag.text+"</span>");
				}
			});
		}		
		
		stories.push( {
			domRoot: this,
			date: AJKHelpers.dateFromMySQLDate({dateString: $(this).find(".story-start-date").text() }),
			endDate: AJKHelpers.dateFromMySQLDate({dateString: $(this).find(".story-end-date").text() }),
			dateFormat: dateFormat
		});
	});


	$.each(stories, function() {
		var startDate = AJKHelpers.formatDate({ date: this.date, formatString: this.dateFormat });
		var endDate = AJKHelpers.formatDate({ date: this.endDate, formatString: this.dateFormat });
		var displayDate = (startDate != endDate) ? startDate+" - "+endDate : startDate;
		$(this.domRoot).find(".story-start-date").text(displayDate);
	});
	
	var spans = [];
	var spanDateFormat = $("#span-data-holder").attr("rel");
	spanDateFormat = (spanDateFormat=="auto") ? defaultDateFormat : spanDateFormat;

	$("#span-data-holder .span").each( function() {
		var spanId = $(this).attr("spanid");
		var spanTitle = $(this).find(".span-title").text();
		var spanStart = $(this).find(".span-start").text();
		var spanEnd = $(this).find(".span-end").text();
		
		var thisSpan = {
			domRoot: this,
			date: AJKHelpers.dateFromMySQLDate({dateString: spanStart }),
			start: AJKHelpers.dateFromMySQLDate({dateString: spanStart }),
			end: AJKHelpers.dateFromMySQLDate({dateString: spanEnd })
		}
		
		spans.push(thisSpan);
		$(this).find(".span-start").text(AJKHelpers.formatDate({ date: thisSpan.start, formatString: spanDateFormat }));
		$(this).find(".span-end").text(AJKHelpers.formatDate({ date: thisSpan.end, formatString: spanDateFormat }));


	});

	var orderedItems = [];
	$.each(stories, function() {
		orderedItems.push(this);
	});
	$.each(spans, function() {
		orderedItems.push(this);
	});

	orderedItems = orderedItems.sort(function(a,b) {
		return (a.date.getTime() > b.date.getTime()) ? 1 : -1; 
	});

	$.each(orderedItems, function() {
		$("#story-holder").append(this.domRoot);
	});

}

var TLLoadTimelineFromData = function(timelineData) {
	eval(timelineData);
	$("#main-title").text(TLTimelineData.title);
	$("#main-intro").text(TLTimelineData.introText);
	$("#printContainer").attr("language",TLTimelineData.language);
	var mainAboutText = "<p>"+TLTimelineData.aboutText.replace(/;xNLx;/g,"</p><p>")+"</p>";
    TLDefaultDateFormat = TLTimelineData.storyDateFormat;

    $("#main-about-text").html(mainAboutText);
    
    var catHTML = "";
	$.each(TLTimelineData.categories, function() {
		var thisCat = this;
		catHTML += '<div class="category" catid="'+thisCat.id+'">'+thisCat.title+'</div>';
	});

    var tagHTML = "";
	$.each(TLTimelineData.tags, function() {
		var thisTag = this;
		tagHTML += '<div class="tag" tagid="'+thisTag.id+'">'+thisTag.text+'</div>';
	});

    var spanHTML = "";
	$.each(TLTimelineData.spans, function() {
		var thisSpan = this;
		
		var extraClass = (thisSpan.image) ? " story-block-image": "";
		spanHTML += '<div class="span story-block-span story-block'+extraClass+'" spanid="'+thisSpan.id+'">';
		if (thisSpan.image) {
			spanHTML += '<img src="'+thisSpan.image+'" />';
		}
		spanHTML += '<h3 class="span-title">'+thisSpan.title+'</h3>';
		spanHTML += '<h4><span class="span-start">'+thisSpan.start+'</span> - <span class="span-end">'+thisSpan.end+'</span></h4>';
		spanHTML += '<div class="divider"></div>';
		
		spanHTML += '</div>';
		
	});
	
	$("#span-data-holder").attr("rel",TLTimelineData.topDateFormat);

	var storyHTML = "";
	$.each(TLTimelineData.stories, function() {
		var thisStory = this;
		var storyImage = (thisStory.media.length > 0 && thisStory.media[0].type == "Image") ? (thisStory.media[0].mediaDataUri || thisStory.media[0].src) : "";
		var storyClass = (storyImage) ? "story-block story-block-image" : "story-block";

		storyHTML += '<div class="'+storyClass+'" rel="'+thisStory.dateFormat+'">';
		if (storyImage) {
			storyHTML += '<img src="'+storyImage+'" />';
		}
		storyHTML += '<h4 class="story-category">'+thisStory.category+'</h4>';
		storyHTML += '<h3>'+thisStory.title+'</h3>';
		storyHTML += '<h4 class="story-start-date">'+thisStory.startDate+'</h4>';
		storyHTML += '<h4 class="story-end-date">'+thisStory.endDate+'</h4>';
		
		storyHTML += '<h5>'+thisStory.text+'</h5>';
		
		storyHTML += '<div class="story-content-fulltext">';
		storyHTML += '<p>'+thisStory.fullText.replace(/;xNLx;/g,"</p><p>")+'</p>';
		if (thisStory.externalLink) {
			storyHTML += '<p class="external-link">'+thisStory.externalLink+'</p>';
		}
		storyHTML += '<div class="story-tags">'+thisStory.tags+'</div>';
		storyHTML += '</div>';
		storyHTML += '<div class="divider"></div>';
		storyHTML += '</div>';
	});

	
	$("#category-data-holder").append(catHTML);
	$("#tag-data-holder").append(tagHTML);
	$("#span-data-holder").append(spanHTML);
	$("#story-holder").append(storyHTML);
	
	processStories();
	
	contentHeight = $("body").height();
}

var TLGetContentHeight = function() {
	return contentHeight;	
}

